 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: Assistant.cpp,v 1.2 2000/11/02 21:39:14 daville Exp $
 * $Log: Assistant.cpp,v $
 * Revision 1.2  2000/11/02 21:39:14  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include "Assistant.h"
#include "gestionobjx.h"
#include <ToolsXMProtocol.h>

typedef struct SConnection
{
	int mID;
	int ID(){return mID;}
	CAssistant *mAssistant;
	XMPipe *mPipe;
	CList<XMObjectX *> * mMemory;
};

/////////////////////////////////////////////
static int IndxConnection=-1;		   //
static CList<SConnection *> ListConnection;//
/////////////////////////////////////////////

SCConnection * ConnectClient()
{
	SConnection *acon;
	SCConnection *accon;
	acon = new SConnection;
	accon = new SCConnection;
	acon->mMemory = new CList<XMObjectX *>;
	accon->mPipe = new XMPipe;
	acon->mPipe = new XMPipe;
	accon->mID = acon->mID = IndxConnection++;
	acon->mAssistant = new CAssistant();
	ListConnection.Add(acon);
	return accon;
}

void * SendToAssistant(int id_client, char *com)
{
	SConnection *acon = ListConnection.GetID(id_client);
	return ((!acon)? acon: ToFileXMReponse(id_client, acon->mAssistant->AppelerAssistant(com, id_client, acon->mPipe->IDWrite)));
}

int   DisconnectClient(int id_user, void (*DeleteFlux)(XMPipe *&pipe, int id_user))
{
	SConnection *acon;
	if (!(acon = ListConnection.GetID(id_user))) return 0;
	if (DeleteFlux) (*DeleteFlux)(acon->mPipe, acon->mID);
	delete acon->mMemory;
	ListConnection.Del(acon);
	delete acon->mAssistant;
	delete acon;
	return 1;
}

int DisconnectAllClient(void (*DeleteFlux)(XMPipe *&pipe, int id_user))
{
	if (DeleteFlux) return 0;
	return 0;
}

XMPipe *GetPipeConnection(int k)
{
	if (k < ListConnection.GetCount()) return ListConnection.Get(k)->mPipe;
	return NULL;
}

XMPipe *GetPipeClient(int id)
{
	return (ListConnection.GetID(id))->mPipe;
}

int AddIntoMemory(int id_client, void *objx)
{
	SConnection *acon;
	if (!(acon = ListConnection.GetID(id_client))) return 0;
	acon->mMemory->Add((XMObjectX *)objx);
	return 1;
}

void *GetObjectX(int id_client, char *name)
{
	return NULL;
}