 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: Avancement.cpp,v 1.2 2000/11/02 21:41:22 daville Exp $
 * $Log: Avancement.cpp,v $
 * Revision 1.2  2000/11/02 21:41:22  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <pthread.h>
#include "Avancement.h"

static int Compteur=0;

int HandleCore::ReachCore(Avancement *av)
{
	return 1;
}

Avancement::Avancement()
{
	mHandleCore = 0;
	mNStage=mNStatement=mStage=mStatement=0;
	mState=XMST_FREE;
	mStageName=NULL;
}

Avancement::Avancement(Avancement *av)
{
	mHandleCore = av->mHandleCore;
	mNStage = av->mNStage;
	mNStatement = av->mNStatement;
	mStage = av->mStage;
	mState = av->mState;
	mStageName = av->mStageName;
}


HandleCore *&Avancement::Handle()
{
	return mHandleCore;
}

void *filet(void *av)
{
	Avancement *pAv = (Avancement *)av;
	pAv->Handle()->ReachCore(pAv);
	return NULL;
}

int Avancement::ReachCore()
{
	printf("XM_MSG: 1. Appel Callback noyau [%d]\n", Compteur);
	printf("XM_MSG: 2. Appel Callback noyau [%d]\n", Compteur);
	if (!mHandleCore) return -1;
	mHandleCore->ReachCore(this);
	printf("XM_MSG: Fin Callback noyau [%d]\n", Compteur);
	return 0;
}

int &Avancement::NStage()
{
	return mNStage;
}

int &Avancement::NStatement()
{
	return mNStatement;
}

int &Avancement::Stage()
{
	return mStage;
}

int &Avancement::Statement()
{
	return mStatement;
}

int &Avancement::State()
{
	return (int &)mState;
}

int Avancement::IsVoid()
{
	return mState==XMST_VOID;
}

int Avancement::IsBusy()
{
	return mState==XMST_BUSY;
}

int Avancement::IsFree()
{
	if (mState==XMST_FREE) {mState=XMST_BUSY;return 1;}
	return 0;
}

int Avancement::SetBusy()
{
	if (mState==XMST_BUSY) {return 0;}
	mState=XMST_BUSY;
	return 1;
}

int Avancement::SetVoid()
{
	if (mState==XMST_BUSY) {return 0;}
	mState=XMST_VOID;
	return 1;
}

int Avancement::SetFree()
{
	mState=XMST_FREE;
	return 1;
}

double Avancement::Total()
{
	return (mNStage*mNStatement);
}

char *&Avancement::StageName()
{
	return mStageName;
}