 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: FuncOpComparaison.cpp,v 1.2 2000/11/02 21:48:35 daville Exp $
 * $Log: FuncOpComparaison.cpp,v $
 * Revision 1.2  2000/11/02 21:48:35  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <FuncOpComparaison.h>

#define PFUNCTION(X, Y) (bool (*)(X ,  Y, void *, void *))

/****************************************************************/
/*  Dfintion des onctions pour l'oprateur de comparaison '<'	*/
/****************************************************************/
/****************************************************************/
template <class X, class Y> bool ErreurComparaisonXY(X, Y, void *val1, void *val2)
{
	return false;
}
/****************************************************************/

/****************************************************************/
/*  Dfintion des onctions pour l'oprateur de comparaison '<'	*/
/****************************************************************/
/****************************************************************/
template <class X, class Y> bool StrictementInferieurXY(X, Y, void *val1, void *val2)
{
	X *aValue1;
	Y *aValue2;
	aValue1 = (X *)val1;
	aValue2 = (Y *)val2;
	return ((X (*aValue1)) < (Y (*aValue2)));
}
/****************************************************************/


/****************************************************************/
/*  Dfintion des onctions pour l'oprateur de comparaison '>'	*/
/****************************************************************/
/****************************************************************/
template <class X, class Y> bool StrictementSuperieurXY(X, Y, void *val1, void *val2)
{
	printf("Appel fonction de comparaison >\n");
	X *aValue1;
	Y *aValue2;
	aValue1 = (X *)val1;
	aValue2 = (Y *)val2;
	return ((X (*aValue1)) > (Y (*aValue2)));
}
/****************************************************************/

/****************************************************************/
/*  Dfintion des onctions pour l'oprateur de comparaison '<='	*/
/****************************************************************/
/****************************************************************/
template <class X, class Y> bool InferieurOuEgalXY(X, Y, void *val1, void *val2)
{
	X *aValue1;
	Y *aValue2;
	aValue1 = (X *)val1;
	aValue2 = (Y *)val2;
	return ((X (*aValue1)) <= (Y (*aValue2)));
}
/****************************************************************/

/****************************************************************/
/*  Dfintion des onctions pour l'oprateur de comparaison '>='	*/
/****************************************************************/
/****************************************************************/
template <class X, class Y> bool SuperieurOuEgalXY(X, Y, void *val1, void *val2)
{
	X *aValue1;
	Y *aValue2;
	aValue1 = (X *)val1;
	aValue2 = (Y *)val2;
	return ((X (*aValue1)) >= (Y (*aValue2)));
}
/****************************************************************/

/****************************************************************/
/*  Dfintion des onctions pour l'oprateur de comparaison '=='	*/
/****************************************************************/
/****************************************************************/
template <class X, class Y> bool EgalXY(X, Y, void *val1, void *val2)
{
	X *aValue1;
	Y *aValue2;
	aValue1 = (X *)val1;
	aValue2 = (Y *)val2;
	return ((X (*aValue1)) == (Y (*aValue2)));
}
/****************************************************************/
/****************************************************************/



CEvaluator ***GetTABFonctionComparateur(TOperator top)
{
	int i=0, j=0;
	CEvaluator ***pEvaluator=NULL;
	CEvaluator **aTABEvaluator;
	switch (top)
	{
		case TOP_STRICT_INF: //Operateur '<'
			{
				pEvaluator = new (CEvaluator **)[TV_LAST];
				for (i=0; i < TV_LAST; i++) pEvaluator[i] = new (CEvaluator *);
				
				i = 0;
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			short			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<short, short>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, int>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long int>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long long>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, float>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);	i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			int			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<int, short>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<int, int>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long int>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<int, long>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long long>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<int, float>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<int, double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<int, long double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);	i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long int		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long int, short>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, int>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long int>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long long>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long int, float>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, double>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long, short>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long, int>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long int>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long, long>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long long>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long, float>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long, double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long, long double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);	i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long long		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long long, short>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, int>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long int>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, long>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long long>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, float>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, double>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			float			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<float, short>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, int>(StrictementInferieurXY);			i++;
				aTABEvaluator[i] = new CComparator<float, long int>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long long>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, float>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, double>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long double>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			double			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<double, short>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, int>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long int>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long long>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, float>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, double>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long double		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long double, short>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, int>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long int>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long long>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, float>(StrictementInferieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long double>(StrictementInferieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			UNKNOWN			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long double, short>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, int>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long int>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long long>(ErreurComparaisonXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, float>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, double>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long double>(ErreurComparaisonXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				return pEvaluator;
			}
		case TOP_STRICT_SUP: //Operateur '>'StrictementSuperieur
			{
				printf("Comparaison > dtecte\n");
				pEvaluator = new (CEvaluator **)[TV_LAST];
				printf("Allocation effectue\n");
				for (i=0; i < TV_LAST; i++) pEvaluator[i] = new (CEvaluator *);
				printf("Initialisation effectue\n");
				
				i = 0;
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			short			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<short, short>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, int>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long int>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long long>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, float>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);	i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			int			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<int, short>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<int, int>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long int>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<int, long>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long long>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<int, float>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<int, double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<int, long double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);	i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long int		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long int, short>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, int>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long int>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long long>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long int, float>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, double>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long, short>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long, int>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long int>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long, long>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long long>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long, float>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long, double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long, long double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);	i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long long		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long long, short>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, int>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long int>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, long>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long long>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, float>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, double>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			float			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<float, short>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, int>(StrictementSuperieurXY);			i++;
				aTABEvaluator[i] = new CComparator<float, long int>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long long>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, float>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, double>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long double>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			double			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<double, short>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, int>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long int>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long long>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, float>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, double>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long double		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long double, short>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, int>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long int>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long long>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, float>(StrictementSuperieurXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long double>(StrictementSuperieurXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			UNKNOWN			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long double, short>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, int>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long int>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long long>(ErreurComparaisonXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, float>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, double>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long double>(ErreurComparaisonXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				printf("Fin chargement [%d]*[%d]\n", TV_LAST-1, j-1);
				return pEvaluator;
			}
		case TOP_INF_OU_EGAL: //Operateur '<='InferieurOuEgal
			{
				pEvaluator = new (CEvaluator **)[TV_LAST];
				for (i=0; i < TV_LAST; i++) pEvaluator[i] = new (CEvaluator *);
				
				i = 0;
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			short			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<short, short>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long long>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, float>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, double>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long double>(InferieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<short, long double>(InferieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			int			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<int, short>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long long>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, float>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, double>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long double>(InferieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<int, long double>(InferieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long int		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long int, short>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long int>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long int, long>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long long>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long int, float>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, double>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long int, long double>(InferieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<long int, long double>(InferieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long, short>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long long>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, float>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, double>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long double>(InferieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<long, long double>(InferieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long long		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long long, short>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long int>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, long>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long long>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, float>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, double>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, long double>(InferieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<long long, long double>(InferieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			float			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<float, short>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long long>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<float, float>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, double>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long double>(InferieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<float, long double>(InferieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			double			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<double, short>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, int>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long int>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<double, long>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long long>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<double, float>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, double>(InferieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long double>(InferieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<double, long double>(InferieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long double		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long double, short>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, int>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long int>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long long>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, float>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, double>(InferieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long double>(InferieurOuEgalXY);i++;
				//aTABEvaluator[i] = new CComparator<long double, long double>(InferieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			UNKNOWN			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long double, short>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, int>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long int>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long long>(ErreurComparaisonXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, float>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, double>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long double>(ErreurComparaisonXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				return pEvaluator;
			}
		case TOP_SUP_OU_EGAL: //Operateur '>='
			{
				pEvaluator = new (CEvaluator **)[TV_LAST];
				for (i=0; i < TV_LAST; i++) pEvaluator[i] = new (CEvaluator *);
				
				i = 0;
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			short			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<short, short>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long long>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<short, float>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, double>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long double>(SuperieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<short, long double>(SuperieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			int			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<int, short>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long long>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, float>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, double>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long double>(SuperieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<int, long double>(SuperieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long int		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long int, short>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long int>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long int, long>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long long>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long int, float>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, double>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long int, long double>(SuperieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<long int, long double>(SuperieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long, short>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long long>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, float>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, double>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long double>(SuperieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<long, long double>(SuperieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long long		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long long, short>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long int>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, long>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long long>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, float>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, double>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, long double>(SuperieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<long long, long double>(SuperieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			float			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<float, short>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long long>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<float, float>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, double>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long double>(SuperieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<float, long double>(SuperieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			double			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<double, short>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, int>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long int>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<double, long>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long long>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<double, float>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, double>(SuperieurOuEgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long double>(SuperieurOuEgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<double, long double>(SuperieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long double		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long double, short>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, int>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long int>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long long>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, float>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, double>(SuperieurOuEgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long double>(SuperieurOuEgalXY);i++;
				//aTABEvaluator[i] = new CComparator<long double, long double>(SuperieurOuEgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			UNKNOWN			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long double, short>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, int>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long int>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long long>(ErreurComparaisonXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, float>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, double>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long double>(ErreurComparaisonXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				return pEvaluator;
			}
		case TOP_EGAL_EGAL: //Operateur '=='
			{
				pEvaluator = new (CEvaluator **)[TV_LAST];
				for (i=0; i < TV_LAST; i++) pEvaluator[i] = new (CEvaluator *);
				
				i = 0;
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			short			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<short, short>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<short, int>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<short, long int>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long long>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<short, float>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<short, double>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(EgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<short, long double>(EgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			int			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<int, short>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, int>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long int>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<int, long>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, long long>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<int, float>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<int, double>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<int, long double>(EgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<int, long double>(EgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long int		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long int, short>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, int>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long int>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long long>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long int, float>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, double>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long int, long double>(EgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<long int, long double>(EgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long, short>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long, int>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long int>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long, long>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long, long long>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long, float>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long, double>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long, long double>(EgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<long, long double>(EgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long long		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long long, short>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, int>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long int>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, long>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long long>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long long, float>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, double>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long long, long double>(EgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<long long, long double>(EgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			float			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<float, short>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, int>(EgalXY);			i++;
				aTABEvaluator[i] = new CComparator<float, long int>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long long>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, float>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, double>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<float, long double>(EgalXY);		i++;
				//aTABEvaluator[i] = new CComparator<float, long double>(EgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			double			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<double, short>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, int>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long int>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long long>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, float>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, double>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<double, long double>(EgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<double, long double>(EgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			long double		////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long double, short>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, int>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long int>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long long>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, float>(EgalXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, double>(EgalXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, long double>(EgalXY);	i++;
				//aTABEvaluator[i] = new CComparator<long double, long double>(EgalXY);i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				
				////////////////////////////////////////////////////////////////////////////////////
				///////////////////////			UNKNOWN			////////////////////
				////////////////////////////////////////////////////////////////////////////////////
				aTABEvaluator = new (CEvaluator *)[TV_LAST];
				aTABEvaluator[i] = new CComparator<long double, short>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, int>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long int>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long long>(ErreurComparaisonXY);	i++;
				aTABEvaluator[i] = new CComparator<long double, float>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, double>(ErreurComparaisonXY);		i++;
				aTABEvaluator[i] = new CComparator<long double, long double>(ErreurComparaisonXY);	i++;
				aTABEvaluator[i] = new CComparator<short, long double>(ErreurComparaisonXY);		i++;
					pEvaluator[j] = aTABEvaluator;	i=0; j++;
				////////////////////////////////////////////////////////////////////////////////////
				
				return pEvaluator;
			}
		default: return pEvaluator;
	}
}

void ReleaseTABComparateur(CEvaluator ***&pEvaluator)
{
	if (pEvaluator == NULL) return;
	for(int i=0; i<TV_LAST; i++)
		for(int j=0; j<TV_LAST; j++)
		{
			printf("[%d][%d]\n", i, j);
			if (pEvaluator[i][j])
			{
				printf("SUP:		[%d][%d]\n", i, j);
				delete pEvaluator;
			}
		}
	delete pEvaluator;
	pEvaluator = NULL;
}
