 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: Pile.h,v 1.2 2000/11/02 22:09:52 daville Exp $
 * $Log: Pile.h,v $
 * Revision 1.2  2000/11/02 22:09:52  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef PILE_H
#define PILE_H

typedef struct SPile
{
        void *PInfo;
        struct SPile *Prec;
}SPile;

template <class T> class Pile
{
	protected:
		SPile *mCourant;
	public:
		Pile(){ mCourant=NULL;};
		Pile(Pile &pile);
		void Empiler(T info); 				// Permet d'ajouter un element T 
		void Depiler(T &info);				// Renvoye le premier elmt de la pile
		T Get(){return *((T*)(mCourant->PInfo));};	//& de l'element courant
		int Occurrence();
		int Vide(){return (!(int)mCourant);};
		Pile & operator=(Pile &pile);
		~Pile();
};

template <class T> Pile<T>::Pile(Pile &pile)
{
        SPile *Ptr=pile.mCourant,*P,*M;
        T *PtrInfo;
        mCourant=NULL;
        while (Ptr)
        {
                P=new SPile;
                PtrInfo = new T;
                *PtrInfo = *((T*)(Ptr->PInfo));
                P->PInfo = (void *)PtrInfo;
                Ptr=Ptr->Prec;
                if (!mCourant)
                {
                        mCourant=P;
                        P->Prec=NULL;
                } else M->Prec=P;
                M=P;
        }
}

template <class T> void Pile<T>::Empiler(T info)
{
       SPile *P;
       T *ptr=new T;
       P=mCourant;
       mCourant=new SPile;
       mCourant->Prec=P;
       *ptr=info;
       mCourant->PInfo=(void *)ptr;
}

template <class T> void Pile<T>::Depiler(T &info)
{
        if (mCourant)
        {
                SPile *P;
                info=*((T*)(mCourant->PInfo));
        	P=mCourant;  mCourant=mCourant->Prec;
        	delete P->PInfo; delete P;
        }
}

template <class T> Pile<T> & Pile<T>::operator=(Pile &pile)
{
        Pile p(pile);
        return p;
}

template <class T> int Pile<T>::Occurrence()
{
        int Nbre = 0;
        SPile *Ptr = mCourant;
        
        while (Ptr)
        {
                Ptr = Ptr->Prec;
                Nbre++;
        }
        return Nbre;
}
                                        
template <class T> Pile<T>::~Pile()
{
        SPile *P;
        while (mCourant)
        {
                P=mCourant;
                mCourant=mCourant->Prec;
        	delete P->PInfo; delete P;
        }
}
#endif       /*	PILE_H	*/