 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: XMCore.h,v 1.2 2000/11/02 22:09:34 daville Exp $
 * $Log: XMCore.h,v $
 * Revision 1.2  2000/11/02 22:09:34  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <XMProtocol.h>
#include <FichierConf.h>


#ifndef XMCORE_H
#define XMCORE_H

typedef struct XMSender
{
	XMPipe *mPipe;
	XMQuery *mQuery;
	int mState;
	void Set(XMPipe *pipe, XMQuery *query, int &state)
	{
		mPipe = pipe;
		mQuery = query;
		mState = state;
	}
};

XMPipe *CreerPipe();
XMQuery *LireRequete(XMPipe *pipe);
int Dispatche(XMQuery *pQuery);
void *TraiterRequete(void *sender);
int EnvoyerReponse(XMPipe *pipe, XMReponse *pReponse);
int DeconnecterClient(XMPipe *pipe);
int FermerPipe(XMPipe *&pipe);

#endif  /* XMCORE_H */