 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: XMProtocol.h,v 1.2 2000/11/02 22:09:22 daville Exp $
 * $Log: XMProtocol.h,v $
 * Revision 1.2  2000/11/02 22:09:22  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef XMQUERY_H
#define XMQUERY_H

#define MAXI_LEN_QUERY		1026*1026
#define MAXI_LEN_REPONSE	1026


typedef struct XMPipe
{
	int  IDRead;
	int  IDWrite;
};

typedef struct XMQuery
{
	int  IDClient;
	int  IDQuery;
	char Query[MAXI_LEN_QUERY];
};

typedef struct XMReponse
{
	int  IDClient;
	int  IDReponse;
	char Reponse[MAXI_LEN_REPONSE];
};

typedef struct SCConnection  // Structure d'une connection cliente
{
	int	mID;	// Numero de la connection/IDClient
	XMPipe *mPipe;	// Objet de communication
};


#define XMSERVER_AVANCEMENT	0xF00
#define XMSERVER_XMOBJECTX	0xF01


#define CQUNKNOWN		0x000
#define CQCONNECTION		0x001
#define CQDECONNECTION		0x002   // Dconnection
#define CQSHUTDOWN		0x003
#define CQSCRIPT		0x010
#define CQFCN_TOTO		0x020
#define CQGETALLOBJECX		0x030


#define XMRUNKNOWN		0x100
#define XMRCONNECTION		0x101
#define XMRDECONNECTION		0x102
#define XMRSHUTDOWN		0x103
#define XMRERROR		0x104
#define XMROK			0x105
#define XMRINFO			0x106
#define XMRFREPONSE		0x110
#define XMRAVANCEMENT		0x111
#define XMRFCN_TOTO		0x120


#endif  /* XMCORE_H */