 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: XMValueX.cpp,v 1.2 2000/11/02 22:08:58 daville Exp $
 * $Log: XMValueX.cpp,v $
 * Revision 1.2  2000/11/02 22:08:58  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <FuncOpComparaison.h>
#include <XMValueX.h>


CEvaluator ***GetTABComparateur(TOperator top)
{
	printf("1. TOTO %d\n", top);
	if ((top<0) || (top>=TNSOP_LAST)) return NULL;
	printf("2. TOTO\n");
	return GetTABFonctionComparateur(top);
}

bool TABComparateurExecStrictementInferieur(XMValueX *val1, XMValueX *val2)
{
	bool Res;
	CEvaluator ***aTABComparateur;
	aTABComparateur = GetTABComparateur(TOP_STRICT_INF);
	Res = (aTABComparateur[val1->GetType()][val2->GetType()])->Evaluate(val1->GetValue(), val2->GetValue());	
	ReleaseTABComparateur(aTABComparateur);
	return Res;
}

bool TABComparateurExecStrictementSuperieur(XMValueX *val1, XMValueX *val2)
{
	bool Res;
	printf("1.OK\n");
	CEvaluator ***aTABComparateur;
	printf("2.OK %d\n", TOP_STRICT_SUP);
	aTABComparateur = GetTABComparateur(TOP_STRICT_SUP);
	printf("3.OK  [%d][%d]\n", val1->GetType(), val2->GetType());
	Res = (aTABComparateur[val1->GetType()][val2->GetType()])->Evaluate(val1->GetValue(), val2->GetValue());	
	printf("4.OK\n");
	ReleaseTABComparateur(aTABComparateur);
	printf("5.OK\n");
	return Res;
}

bool TABComparateurExecInferieurOuEgal(XMValueX *val1, XMValueX *val2)
{
	bool Res;
	CEvaluator ***aTABComparateur;
	aTABComparateur = GetTABComparateur(TOP_INF_OU_EGAL);
	Res = (aTABComparateur[val1->GetType()][val2->GetType()])->Evaluate(val1->GetValue(), val2->GetValue());	
	ReleaseTABComparateur(aTABComparateur);
	return Res;
}

bool TABComparateurExecSuperieurOuEgal(XMValueX *val1, XMValueX *val2)
{
	bool Res;
	CEvaluator ***aTABComparateur;
	aTABComparateur = GetTABComparateur(TOP_SUP_OU_EGAL);
	Res = (aTABComparateur[val1->GetType()][val2->GetType()])->Evaluate(val1->GetValue(), val2->GetValue());	
	ReleaseTABComparateur(aTABComparateur);
	return Res;
}

bool TABComparateurExecEgal(XMValueX *val1, XMValueX *val2)
{
	bool Res;
	CEvaluator ***aTABComparateur;
	aTABComparateur = GetTABComparateur(TOP_EGAL_EGAL);
	Res = (aTABComparateur[val1->GetType()][val2->GetType()])->Evaluate(val1->GetValue(), val2->GetValue());	
	ReleaseTABComparateur(aTABComparateur);
	return Res;
}


XMValueX::XMValueX()
{
	mType = TV_UNKNOWN;
	mSignificatif = XM_DEFAULT_SIGNIFICATIF;
	mValue = NULL;
}

XMValueX::XMValueX(TValueX type, int significatif = XM_DEFAULT_SIGNIFICATIF)
{
	mType = TV_UNKNOWN;
	mSignificatif = XM_DEFAULT_SIGNIFICATIF;
	mValue = NULL;
	if (type == TV_UNKNOWN) return;
	mType = type;
	mSignificatif = significatif;
}

bool XMValueX::InitialiserValue(TValueX type, void *val)
{
	if (val == NULL) return false;
	switch (type)
	{
		/*case TV_BYTE:
			{
				short *pByte;
				pByte = new short;
				*pByte = (short)(*val);
				mValue = (void *)pByte;
			}
		case TV_LONG_BYTE:
			{
				long short *pLongByte;
				pLongByte = new long short;
				*pLongByte = (long short)(*val);
				mValue = (void *)pLongByte;
			}*/
		case TV_LONG:
			{
				long *pVal;
				long *pVoidValue = (long *)val;
				pVal = new long;
				*pVal = (long)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_LONG_LONG:
			{
				long long *pVal;
				long long *pVoidValue = (long long *)val;
				pVal = new long long;
				*pVal = (long long)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_INT:
			{
				int *pVal;
				int *pVoidValue = (int *)val;
				pVal = new int;
				*pVal = (int)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_LONG_INT:
			{
				long int *pVal;
				long int *pVoidValue = (long int *)val;
				pVal = new long int;
				*pVal = (long int)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_FLOAT:
			{
				float *pVal;
				float *pVoidValue = (float *)val;
				pVal = new float;
				*pVal = (float)(*pVoidValue);
				mValue = (void *)pVal;
			}/*
		case TV_LONG_FLOAT:
			{
				long float *pVal;
				long float *pVoidValue = (long float *)val;
				pVal = new long float;
				*pVal = (long float)(*pVoidValue);
				mValue = (void *)pVal;
			}*/
		case TV_DOUBLE:
			{
				double *pVal;
				double *pVoidValue = (double *)val;
				pVal = new double;
				*pVal = (double)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_LONG_DOUBLE:
			{
				long double *pVal;
				long double *pVoidValue = (long double*)val;
				pVal = new long double;
				*pVal = (long double)(*pVoidValue);
				mValue = (void *)pVal;
			}
		default: return false;
	}
	return true;
}

XMValueX XMValueX::operator= (XMValueX valx)
{
	if (mValue) delete mValue;
	mType = valx.mType;
	if (!InitialiserValue(valx.mType, valx.mValue)) mType = TV_UNKNOWN;
	return *this;
}

XMValueX XMValueX::operator= (long val)
{
	if (mValue) delete mValue;
	if (!InitialiserValue(TV_LONG, (void *)&val)) mType = TV_UNKNOWN;
	mType = TV_LONG;
	return *this;
}

XMValueX XMValueX::operator= (long long val)
{
	if (mValue) delete mValue;
	mType = TV_LONG_LONG;
	if (!InitialiserValue(TV_LONG_LONG, (void *)&val)) mType = TV_UNKNOWN;
	return *this;
}

XMValueX XMValueX::operator= (int val)
{
	if (mValue) delete mValue;
	mType = TV_INT;
	if (!InitialiserValue(TV_INT, (void *)&val)) mType = TV_UNKNOWN;
	return *this;
}

/*
XMValueX XMValueX::operator= (long int val)
{
	if (mValue) delete mValue;
	if (!InitialiserValue(TV_LONG_INT, (void *)&val)) mType = TV_UNKNOWN;
	mType = TV_LONG_INT;
}*/

XMValueX XMValueX::operator= (float val)
{
	if (mValue) delete mValue;
	mType = TV_FLOAT;
	if (!InitialiserValue(TV_FLOAT, (void *)&val)) mType = TV_UNKNOWN;
	return *this;
}

/*
XMValueX XMValueX::operator= (long float val)
{
	if (mValue) delete mValue;
	if (!InitialiserValue(TV_LONG_FLOAT, (void *)&val)) mType = TV_UNKNOWN;
	mType = TV_LONG_FLOAT;
}*/

XMValueX XMValueX::operator= (double val)
{
	if (mValue) delete mValue;
	mType = TV_DOUBLE;
	if (!InitialiserValue(TV_DOUBLE, (void *)&val)) mType = TV_UNKNOWN;
	return *this;
}

XMValueX XMValueX::operator= (long double val)
{
	if (mValue) delete mValue;
	mType = TV_LONG_DOUBLE;
	if (!InitialiserValue(TV_LONG_DOUBLE, (void *)&val)) mType = TV_UNKNOWN;
	return *this;
}
	
// Oprateur d'opartion
XMValueX XMValueX::operator+(XMValueX valx)
{
	/*if (valx.mValue == NULL) return *this;
	switch (valx.mType)
	{
		/*case TV_BYTE:
			{
				short *pByte;
				pByte = new short;
				*pByte = (short)(*val);
				mValue = (void *)pByte;
			}
		case TV_LONG_BYTE:
			{
				long short *pLongByte;
				pLongByte = new long short;
				*pLongByte = (long short)(*val);
				mValue = (void *)pLongByte;
			}
		case TV_LONG:
			{
				long *pVal;
				long *pVoidValue = (long *)valx;
				pVal = new long;
				*pVal = (long)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_LONG_LONG:
			{
				long long *pVal;
				long long *pVoidValue = (long long *)valx;
				pVal = new long long;
				*pVal = (long long)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_INT:
			{
				int *pVal;
				int *pVoidValue = (int *)val;
				pVal = new int;
				*pVal = (int)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_LONG_INT:
			{
				long int *pVal;
				long int *pVoidValue = (long int *)valx;
				pVal = new long int;
				*pVal = (long int)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_FLOAT:
			{
				float *pVal;
				float *pVoidValue = (float *)valx;
				pVal = new float;
				*pVal = (float)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_LONG_FLOAT:
			{
				long float *pVal;
				long float *pVoidValue = (long float *)val;
				pVal = new long float;
				*pVal = (long float)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_DOUBLE:
			{
				double *pVal;
				double *pVoidValue = (double *)valx;
				pVal = new double;
				*pVal = (double)(*pVoidValue);
				mValue = (void *)pVal;
			}
		case TV_LONG_DOUBLE:
			{
				long double *pVal;
				long double *pVoidValue = (long double*)valx;
				pVal = new long double;
				*pVal = (long double)(*pVoidValue);
				mValue = (void *)pVal;
			}
		default: return false;
	}*/
	return *this;
}

XMValueX XMValueX::operator-(XMValueX valx)
{
}

XMValueX XMValueX::operator*(XMValueX valx)
{
}

XMValueX XMValueX::operator/(XMValueX valx)
{
}


// Oprateur de comparaison
bool XMValueX::operator<(XMValueX valx)
{
	if ((!mValue) || (!valx.mValue)) return false;
	if ((mType==TV_UNKNOWN) || (valx.mType==TV_UNKNOWN)) return false;
	return TABComparateurExecStrictementInferieur(this, &valx);
}

bool XMValueX::operator>(XMValueX valx)
{
	if ((!mValue) || (!valx.mValue)) return false;
	if ((mType==TV_UNKNOWN) || (valx.mType==TV_UNKNOWN)) return false;
	return TABComparateurExecStrictementSuperieur(this, &valx);
}

bool XMValueX::operator<=(XMValueX valx)
{
	if ((!mValue) || (!valx.mValue)) return false;
	if ((mType==TV_UNKNOWN) || (valx.mType==TV_UNKNOWN)) return false;
	return TABComparateurExecInferieurOuEgal(this, &valx);
}

bool XMValueX::operator>=(XMValueX valx)
{
	if ((!mValue) || (!valx.mValue)) return false;
	if ((mType==TV_UNKNOWN) || (valx.mType==TV_UNKNOWN)) return false;
	return TABComparateurExecSuperieurOuEgal(this, &valx);
}

bool XMValueX::operator==(XMValueX valx)
{
	if ((!mValue) || (!valx.mValue)) return false;
	if ((mType==TV_UNKNOWN) || (valx.mType==TV_UNKNOWN)) return false;
	return TABComparateurExecEgal(this, &valx);
}

void XMValueX::SetValue(TValueX type, void *val)
{
	if (mValue) delete mValue;
	if (!InitialiserValue(TV_LONG, &val)) mType = TV_UNKNOWN;
	mType = type;
}

TValueX XMValueX::GetType()
{
	return mType;
}
	
char *XMValueX::GetFormat()
{
	switch (mType)
	{
		case TV_UNKNOWN		: return NULL;
		case TV_SHORT	 	: return "%st";
		case TV_LONG	 	: return "%l";
		case TV_LONG_LONG	: return "%ll";
		case TV_INT		: return "%d";
		case TV_LONG_INT	: return "%ld";
		case TV_FLOAT		: return "%d";
		case TV_DOUBLE		: return "%lf";
		case TV_LONG_DOUBLE	: return "%lf";
		default			: return NULL;
	}
}

void *XMValueX::GetValue()
{
	return mValue;
}
	
void XMValueX::ConvertTo(TValueX tval)
{
	mType = tval;
	if (mType != TV_UNKNOWN) return;
	if (mValue) delete mValue;
	mValue = NULL;
}