 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: chaine.cpp,v 1.2 2000/11/02 21:42:31 daville Exp $
 * $Log: chaine.cpp,v $
 * Revision 1.2  2000/11/02 21:42:31  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "chaine.h"

void Set(char **s, char *so)
{
        s[0]= new char[strlen(so)+1];
        strcpy(s[0],so);
}

int EstCommande(char *Exp)
{
        return ((!strcmp(Exp,"exit")) || (!strcmp(Exp,"save")));
}

int EstDansAZaz(char c)
{
        if (((c>=65) && (c<=90)) || ((c>=97) && (c<=122))) return 1; else return 0;
}

int EstDans09(char c) // permet  de savoir si c E [|0, 9 |]
{
        return ((c>=48) && (c<=57));
}


// Fonction permettant de savoir si op est un operateur
int EstOperateur(char *op)
{
	if (!strcmp(op,"+"))	return 2;
	if (!strcmp(op,"-"))	return 2;
	if (!strcmp(op,"/"))	return 2;
	if (!strcmp(op,"*"))	return 2;
	if (!strcmp(op,"^"))	return 2;
	if (!strcmp(op,"="))	return 2;
	if (!strcmp(op,","))	return 2;
	if (!strcmp(op,".."))	return 2;
	if (!strcmp(op,")"))	return 1;
	if (!strcmp(op,"}"))	return 1;
	if (!strcmp(op,"]"))	return 1;
	if (!strcmp(op,"("))	return -1;
	if (!strcmp(op,"{"))	return -1;
	if (!strcmp(op,"["))	return -1;
	return 0;
}

char *InvOp(char *op)
{
	char *Res=NULL;
	if (!strcmp(op,"+"))	return "-";
	if (!strcmp(op,"-"))	return "+";
	if (!strcmp(op,"/"))	return "*";
	if (!strcmp(op,"*"))	return "/";
	if (!strcmp(op,"^"))	return "^";
	if (!strcmp(op,"="))	return "=";
	if (!strcmp(op,","))	return ",";
	if (!strcmp(op,"("))	return ")";
	if (!strcmp(op,"{"))	return "}";
	if (!strcmp(op,"["))	return "]";
	if (!strcmp(op,".."))	return "..";
	if (!strcmp(op,")"))	return "(";
	if (!strcmp(op,"}"))	return "{";
	if (!strcmp(op,"]"))	return "[";
	return Res;
}


int EstNombre(char *Exp)
{
        char *Endptr;
        strtod(Exp,&Endptr);
        return (!*Endptr?1:0);
}

void Decallage(int n, char *Exp) // Le caract  l'enplacement n devient en 0 ...
{
	if (n>strlen(Exp)) return;
        int i;
        for (i=0; Exp[i+n]; i++) Exp[i]=Exp[i+n];Exp[i] = '\0';
}

void Retrait(int n, char *Exp) // Retire les n derniers caract
{
        int m=strlen(Exp);
        if (n>m) return;
        Exp[m-n]='\0';
}

char *Copie(int m, int n, char *Exp) //Renvoie les n 1iers caracteres contenus dans Exp
{
        if ((m>n) || (m<0) || (!Exp)) return NULL;
        int i;
        char *Res;
        Res=new char[n-m+1];
        if (n>strlen(Exp)) n=strlen(Exp);n -= m;
        for (int i=0;i<n;i++) Res[i]=Exp[i+m]; Res[n]='\0';
        return Res;
}

int PositionChar(char c, char *Exp)
{
	if (!Exp) return -1;
        char *Tmp=strchr(Exp,c);
        if (!Tmp) return 0;
        return (int)(Tmp-Exp);
}
                        
int Compte(char *Exp, char c) //compte le nbre de fois que c est repete dans Exp
{
        int n=0;
        if (!Exp) return n;
        Exp=strchr(Exp,c);
        for (;Exp;n++) Exp=strchr(++Exp,c);
        return n;
}

void Effacer(int Dep, int Fin, char *Exp)
{
        if ((Dep>Fin) || (Dep<=0)) return ;
        char *Tmp;
        int i=1;
        Tmp=Exp;
        while (i<Dep) { Tmp++; i++;}
        Decallage((Fin-Dep+1),Tmp);
}

void SansEspace(char *Exp)
{
        int i,n=strlen(Exp);
        for(i=0;i<strlen(Exp);i++) if (Exp[i]==' ') Effacer(i+1,i+1,Exp);
}

void Clean_Parenthese(char *Exp)
{
        int i=strlen(Exp)-1;
        if (Exp[i]!=')') return;
        char *Tmp=Copie(1,i,Exp);
        Decallage(1,Tmp);
        Retrait(1,Tmp);
        if (Compte(Exp,'(')==Compte(Exp,')'))
        {
                Decallage(1,Exp);
        	Retrait(1,Exp);
        	delete Tmp;
      	}
}

void Concatener(char **Exp1, char *Exp)
{
        char *Tmp[2];
        Tmp[0] = *Exp1;
        Tmp[1] = new char[strlen(Tmp[0])+strlen(Exp)+1];
        sprintf(Tmp[1],"%s%s",Tmp[0],Exp);
        delete Tmp[0];
        *Exp1=Tmp[1];
}

void ModifierChaine(char **Exp1, char *Exp)
{
        char *Tmp;
        
        Tmp=new char[strlen(Exp)+1];
        strcpy(Tmp,Exp);
        *Exp1=Tmp;
}


/*************************************************************************************
*										     *
*										     *
*		Fonctions traitant des oprations mathmatiques			     *
*				sur les chaines					     *
*										     *
*************************************************************************************/


char *GetName(char *entete)
{
        int i=0;
        char *Nom;
        for (i=0; EstDansAZaz(entete[i]); i++);
        return Copie(0, i, entete);
}

char *GetEntete(char *exp)
{
      char *Tmp,*entete = 0;
      Tmp = strchr(exp, '=');
      if (Tmp)
      {
      	int Par=0;
      	for(int k=0; k<(Tmp-exp); k++) if (exp[k]=='(') Par++; else if (exp[k]==')') Par--;
      	if (Par) return 0;
        entete = Copie(0, (Tmp-exp), exp);
        Decallage(strlen(entete)+1, exp);
      }
      return entete;
}


char *GetCoord(char *Exp) // Coordonnees separees par des , et decall Exp
{
        int i,n=0;
        char *Res;
        for (i=0;Exp[i];i++)
        {
                if (Exp[i]=='(') n++;
                if (Exp[i]==')') n--;
                if ((!n) && (Exp[i]==','))
                {
                        Res=Copie(1,i,Exp);i++;
                        Decallage(i,Exp);
                        return Res;
                }
        }
        int m=strlen(Exp);
        Res=Copie(1,m,Exp);
        Decallage(m,Exp);
        return Res;
}

void GetNameAndVars(char *entete, char **Nom, char ***Variables, int &nVars)
{
        char *Tmp,*Buff;
        int i,N=0;
        
        Tmp = Copie(0, strlen(entete), entete);
        Buff= strchr(Tmp,'(');
        printf("\n La position de la parenthese ( %d",Buff-Tmp);
        getchar();
        if (!Buff) (*Nom) = Tmp; else
        {
                (*Nom)=new char[(int)(Buff-Tmp)];
                printf("\n On a %d",Buff-Tmp-1);
                for(i=0;i<(int)(Buff-Tmp);i++) (*Nom)[i]=Tmp[i];
                (*Nom)[i]='\0';
                Decallage(strlen(*Nom), Tmp);
                Retrait(1, Tmp);
                printf("\n Nom de la fonction: %s",(*Nom));
                getchar();
                nVars = Compte(Tmp, ',') + 1;
                (*Variables) = new (char*)[nVars];
                for(i=0; i<nVars;i++)
                {
                        (*Variables)[i] = GetCoord(Tmp);
                        printf("*** Reste: %s ***\n", Tmp);
                }
                delete Tmp;
         }
}