 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: chaine.h,v 1.2 2000/11/02 21:42:51 daville Exp $
 * $Log: chaine.h,v $
 * Revision 1.2  2000/11/02 21:42:51  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef CHAINE_H
#define CHAINE_H

void  Set(char **s, char *so);
// Recopie so dans s

int EstCommande(char *exp);

int   EstDansAZaz(char c);
// Teste si c E[A, Z] ou [a, z]


int   EstDans09(char c);
// Teste si c E[0, 9]


int EstOperateur(char *op);
// Test si c est un operateur

char *InvOp(char *op);

int   EstNombre(char *Exp);
// Si Exp est un nombre


char  *Copie(int m, int n, char *Exp);
// Revoie une copie de m  n de Exp


void  Concatener(char **Exp1, char *Exp);
// Rajoute dans Exp1 Exp;


int   Compte(char *Exp, char c);
// Compte de nombre de caracteres c dans Exp


void  Decallage(int n, char *Exp);
// Effectue un dcalage de n caracteres dans Exp


void  Retrait(int n, char *Exp);
// supprime les n derniers caracteres de Exp


int   PositionChar(char c, char *Exp);
// Revoie la position de c dans Exp


void  Effacer(int Deb, int Fin, char *Exp);
// Supprime tous les caractres compris entre Deb en Fin


void  SansEspace(char *Exp);
// Retire tous les espaces de Exp


void  Clean_Parenthese(char *Exp);
// Supprime les parentheses de Exp

//Supprime le contenu de Exp1 et remplace par Exp
void  ModifierChaine(char **Exp1, char *Exp);


/*
*
*
*		Fonctions traitant des oprations mathmatiques
*				sur les chaines
*										*/

char *GetName(char *entete);
char *GetEntete(char *exp);
void GetNameAndVars(char *entete, char **Nom, char ***Variables, int &nVars);
#endif  /*  CHAINE_H  */