 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: complexe.cpp,v 1.2 2000/11/02 21:46:07 daville Exp $
 * $Log: complexe.cpp,v $
 * Revision 1.2  2000/11/02 21:46:07  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <stdlib.h>
#include "complexe.h"
#include "number.h"


CComplexe::CComplexe()
{
        Z=NULL;
}

CComplexe::CComplexe(CComplexe &z)
{
        Z=new SComplexe;
        Z->Re=z.Z->Re;
        Z->Im=z.Z->Im;
}

CComplexe::CComplexe(SComplexe &z)
{
        Z=new SComplexe;
        Z->Re=z.Re;
        Z->Im=z.Im;
}

CComplexe &CComplexe::operator= (CComplexe &z)
{
        Z=new SComplexe;
        Z->Re=z.Z->Re;
        Z->Im=z.Z->Im;
        return *this;
}

CComplexe CComplexe::operator+ (CComplexe &z)
{
        SComplexe zo;
        zo.Re= Z->Re + z.Z->Re;
        zo.Im= Z->Im + z.Z->Im;
        CComplexe Zo(zo);
        return Zo;
}

CComplexe CComplexe::operator* (CComplexe &z)
{
        SComplexe zo;
        zo.Re= Z->Re*z.Z->Re - Z->Im*z.Z->Im;
        zo.Im= Z->Im*z.Z->Re + Z->Re*z.Z->Im;
        CComplexe Zo(zo);
        return Zo;
}

/*
CComplexe::~CComplexe()
{
        if (Z) delete Z;
}
*/