 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: fonction.cpp,v 1.2 2000/11/02 21:48:21 daville Exp $
 * $Log: fonction.cpp,v $
 * Revision 1.2  2000/11/02 21:48:21  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <math.h>
#include <stdlib.h>
#include "fonction.h"
#define T float

T  tan(T x)
{
        return (sin(x)/cos(x));
}

T  arccos(T x)
{
	if (x<0) return (pi- atan(sqrt(1/(x*x)-1)));
	if (x>0) return (atan(sqrt(1/(x*x)-1)));
	if (x=0) return (pi);
}

T  arcsin(T x)
{
	if (x>0) return(pi/2-atan(sqrt(1-x*x)/x));
	if (x>0) return(-pi/2-atan(sqrt(1-x*x)/x));
	if (x=0) return (0);
}

T  argsh(T x)
{
        return(log(x+sqrt(x*x+1)));
}

T  argch(T x)
{
        return(log(x+sqrt(x*x-1)));
}

T  argth(T x)
{
	return(1/2*log((1+x)/(1-x)));
}

T  argcoth(T x)
{
        return(1/2*log((1+x)/(x-1)));
}

T  sh(T x)
{
        return((exp(x)-exp(-x))/2);
}

T  ch(T x)
{
        return((exp(x)+exp(-x))/2);
}

T  th(T x)
{
        return(sh(x)/ch(x));
}

T Power(T x, T n)
{
	if (!n) return 1; else return x*Power(x,n-1);
}

T frac(T x)
{
        return x;
}