 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: gestionobjx.cpp,v 1.2 2000/11/02 21:51:36 daville Exp $
 * $Log: gestionobjx.cpp,v $
 * Revision 1.2  2000/11/02 21:51:36  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <XMProtocol.h>

#include "maths.h"
#include "IXMObjectX.h"

#include "polynome.h"
#include "complexe.h"

#include "gestionobjx.h"
#include "type.h"
#include "chaine.h"
#include "regle.h"
#include "loi.h"
#include "reponse.h"
#include "Erreur.h"
#include "utils.h"
#define  XMWAIT		100

/*

	POUR LES FONCTION EMPILE POST_EMPILE et SCIE VOIR LE
	FICHIER TMP
	
	Le 09 Oct  1999
*/

//XMObjectX *Get_XMObjectX(char *name){}

extern int AddIntoMemory(int id_client, void *objx);

static int gEstOccupe=0;

template <class T> void InitTABCast(OnState st, T*);
template <class T> void InitTABPlus(OnState st, T*);
template <class T> void InitTABEgal(OnState st, T*);
template <class T> void InitTABTrigo(OnState st, T*);
XMObjectX *MakeObjectX(SObjectX *obj, SObjectX *pentete, int flag);



void LectureObjectX(SObjectX *obj)
{
	XMTRACE("Resultat de '+':
	Nom		ObjX		Type
	%s		%s		%d\n",
        obj->Nom, (char *)obj->ObjX, obj->mType);
}

void InitTAB(OnState st)
{
	SObjectX *sob; XMObjectX *mob;
        void AfficheMainTAB();
        CreateTABOperator(st, TOP_EGAL);
        CreateTABOperator(st, TOP_PLUS);
        CreateTABOperator(st, TOP_TRIGO);
	CreateTABOperator(st, TOP_CAST);
	
        if (st==ON_COMPILE)
        {
        	InitTABTrigo(st,sob);
        	InitTABPlus(st,sob);
        	InitTABEgal(st,sob);
        	InitTABCast(st,sob);
        }
        if (st==ON_RUNNING)
        {
        	InitTABTrigo(st,mob);
        	InitTABPlus(st,mob);
        	InitTABEgal(st,mob);
        	InitTABCast(st,mob);
        }
}

XMObjectX *Get_XMObjectX(char *name)
{
	XMObjectX *obj=NULL;
	return obj;
	return (obj=GetObjectX(name)?obj:NULL);
}

TOperator GetTypeObjetX(char *Exp)
{
        TOperator op;

	if (EstCommande(Exp))	return TNSOP_COMM;
	if ((op=(TOperator)IsKeyWord(Exp))!=TOP_UNKNOWN) return op;
        if (EstNombre(Exp))	return TOP_VARIABLE;
	if ((op=GetTSOperator(Exp))!=TOP_UNKNOWN) return op;
	if ((op=GetTNSOperator(Exp))!=TOP_UNKNOWN) return op;
	if (EstVariable(Exp)) return TOP_VARIABLE;
	if ((op=IsSimpleOperator(Exp[0])) != TOP_UNKNOWN) return op ;
        return op;
}

void *Compiler(ArbreM<STree> *aTree, SObjectX *ptrobjx)
{
        XMTRACE("*** Debut de la compilation d'un noeud ***\n");

        STree Stree, *pStree;
        SObjectX *pObjx;
        CReponse *pReponse = NULL;

        aTree->ElementCourant(Stree);
        pStree = aTree->GetPElementCourant();
        XMTRACE("Elment d'un noeud    %s   %d %d\n", Stree.Nom, Stree.mType, Stree.Type);
        if (!strcmp(Stree.Nom,"sin"))
        {
                STree St[2], *stf, *str;
                SObjectX *pObjxf;
                XMTRACE("Compilation pour sinus\n");
                aTree->AllerFilsPremier(St[0]);  	// Fils
                stf = aTree->GetPElementCourant();

                pObjxf = MakeObjectXFromStree(stf);

                aTree->AllerPere(Stree);	 	// Retour sur l'lment initial donc +
                str = aTree->GetPElementCourant();

                pObjx = (SObjectX *)GetResult(ON_COMPILE, TOP_TRIGO, (SObjectX *)NULL, pObjxf);
                if (pObjx->mType == TO_UNKNOWN) 		// Donc ..->ObjX=NULL
                {
                        //pReponse = new CReponse(TR_ERROR, (char *)(pObjx->ObjX), NULL);
                        ReleaseObjectX(pObjx);
                }
                if (pObjx->ObjX)
                {
                        delete (str->Nom);
                        str->Nom = (char *)(pObjx->ObjX);
                        str->mType = pObjx->mType;
                        aTree->AllerFilsPremier(St[0]);
                        aTree->Supprimer();
                }
                delete pObjx;
	        delete pObjxf;
	        XMTRACE("*** Fin de la compilation d'un noeud ***\n");
	        return (void *)(pReponse);

        }
        if (!strcmp(Stree.Nom,"mat"))
        {
                STree stf, *pstf;
                aTree->AllerFilsPremier(stf);
                while (!aTree->FinFrere())
                {
                        pstf = aTree->GetPElementCourant();
                        aTree->AllerFrereSuivant(stf);
                }
                aTree->AllerPere(stf);
                return (void *)(pReponse);
        }
        if (!strcmp(Stree.Nom,"plot"))
        {
        	return (void *)(pReponse);
        }
        if (!strcmp(Stree.Nom,".."))
        {
        	return (void *)(pReponse);
        }
        if (Stree.Nom[0]=='=')
        {
        	return (void *)(pReponse);
        }
        if (Stree.Nom[0]==',')
        {
        	if (pStree->Again()) pStree->mType = pStree->Type;
        	return (void *)(pReponse);
        }
        if (Stree.Nom[0]=='+')
        {
        	XMTRACE("Dbut de la compilation pour  '+'\n");
                STree St[2], *stg, *std, *str;
                SObjectX *pObjxg, *pObjxd;
                aTree->AllerFilsPremier(St[0]);  	// Fils gauche
                stg = aTree->GetPElementCourant();	// Renvoie l'adresse de l'element courant
                aTree->AllerFrereSuivant(St[1]); 	// Fils droite
                std = aTree->GetPElementCourant();

                pObjxg = MakeObjectXFromStree(stg);
                pObjxd = MakeObjectXFromStree(std);

                aTree->AllerPere(Stree);	 	// Retour sur l'lment initial donc +
                str = aTree->GetPElementCourant();

                pObjx = GetResult(ON_COMPILE, TOP_PLUS, pObjxg, pObjxd);

                LectureObjectX(pObjx);

                if (pObjx->mType == TO_UNKNOWN) // Donc ..->ObjX=NULL
                {
                        //pReponse = new CReponse(TR_ERROR, (char *)(pObjx->ObjX), NULL);
                        ReleaseObjectX(pObjx);
                }
                if (pObjx->ObjX)
                {
                        delete (str->Nom);
                        str->Nom = (char *)(pObjx->ObjX);
                        str->mType = pObjx->mType;
                        for (int i=0; i<2; i++)
                       	{
                        	aTree->AllerFilsPremier(St[0]);
                        	aTree->Supprimer();
                        }
                }
                delete pObjx;
	        delete pObjxg;
	        delete pObjxd;
	        XMTRACE("*** Fin de la compilation d'un noeud  '+' ***\n");
        	return (void *)(pReponse);
        }
	if (aTree->ExisteFils()) // Gestion des fonctions  parametres
        {
        	pStree->mType = TO_HEAD;
		XMTRACE("#######  HEAD :   \n");
		return (void *)(pReponse);
        }
        return 0;
}

void *GenererObjectX(ArbreM<STree> *aTree, SObjectX *pentete)
{
        STree Stree, *pStree;
        SObjectX *pObjx;
        XMObjectX *pObjxg, *pObjxd;
        CReponse *pReponse;
        pReponse = NULL;
        aTree->ElementCourant(Stree);
        pStree = aTree->GetPElementCourant();
        XMTRACE("<=====  On est sur: %s  =====>%d  %d\n", pStree->Nom, pStree->mType, pStree->Type);
        if (!strcmp(Stree.Nom,"plot"))
        {
        	STree stf, *st;
        	SObjectX *obj;
        	obj = (st = aTree->AllerFilsPremier(stf))->ObjX; st->ObjX = NULL;
        	aTree->Effacer();
        	pObjx = MakeObjectXFromStree(pStree);
        	pObjx->ObjectX() = obj;
        	pStree->ObjX = (SObjectX*)MakeObjectX(pObjx, pentete, aTree->EstTete() && pentete);
                st->ObjX = NULL;
		return (void *)pReponse;
        }
        if (!strcmp(Stree.Nom,"sin"))
        {
		return (void *)pReponse;
        }
        if (!strcmp(Stree.Nom,"mat"))
        {
                XMTRACE("*************	On a Mat	*************\n");
		STree stf, *st;
        	SObjectX *obj;
        	obj = (st = aTree->AllerFilsPremier(stf))->ObjX; st->ObjX = NULL;
        	aTree->Effacer();
        	pObjx = MakeObjectXFromStree(pStree);
        	pObjx->ObjectX() = obj;
        	pStree->ObjX = (SObjectX*)MakeObjectX(pObjx, pentete, aTree->EstTete() && pentete);
                st->ObjX = NULL;
           	return (void *)(pReponse);
        }
        if (!strcmp(Stree.Nom,".."))
        {
        	STree stf, *pstf;
                CList <XMObjectX *> *lobjx = new CList <XMObjectX *>;
                for(;aTree->ExisteFils();)
                {
                	lobjx->Add((XMObjectX *)((pstf=aTree->AllerFilsPremier(stf))->ObjX));
                	pstf->ObjX = NULL;
                	aTree->Effacer();
                }
                pObjx = MakeObjectXFromStree(pStree);
                pObjx->ObjectX() = lobjx;
                pStree->ObjX = (SObjectX*)MakeObjectX(pObjx, pentete, aTree->EstTete() && pentete);
           	return (void *)(pReponse);
        }
        if (Stree.Nom[0]=='=')
        {
		STree stf[2], *pstf;
		pObjxg = (XMObjectX *)(pstf=aTree->AllerFilsPremier(stf[0]))->ObjX; pstf->ObjX = NULL;
		aTree->Effacer();
                pObjxd = (XMObjectX *)(pstf=aTree->AllerFilsPremier(stf[1]))->ObjX;pstf->ObjX = NULL;
                aTree->Effacer();
                pStree->ObjX = (SObjectX *)GetResult(ON_RUNNING, TOP_EGAL, pObjxg, pObjxd);
                //XMTRACE("{%p}--{%p}  [%d] = [%d]  ----> [%d]\n",pStree,aTree->GetPElementCourant(),pObjxg->Type(), pObjxd->Type(),((XMObjectX *)(pStree->ObjX))->Type());
		//SaveXMObjectX(((XMObjectX *)(pStree->ObjX))->Clone());
                return (void *)(pReponse);
        }
        if (Stree.Nom[0]==',')
        {
                STree stf, *pstf;
                CList <XMObjectX *> *lobjx = new CList <XMObjectX *>;
                for(;aTree->ExisteFils();)
                {
                	lobjx->Add((XMObjectX *)((pstf=aTree->AllerFilsPremier(stf))->ObjX));
                	pstf->ObjX = NULL;
                	aTree->Effacer();
                }
                pObjx = MakeObjectXFromStree(pStree);
                pObjx->ObjectX() = (SObjectX*)lobjx;
                pStree->ObjX = (SObjectX*)MakeObjectX(pObjx, pentete, aTree->EstTete() && pentete);
           	return (void *)(pReponse);
        }
        if (Stree.Nom[0]=='+')
        {
		return (void *)(pReponse);
        }
        if (aTree->ExisteFils()) // Gestion des fonctions  parametres
        {
        	int k;
        	STree stf, *pstf;
        	XMWhole wh(pStree->Nom);
                pObjxd = ((XMObjectX *)((pstf=aTree->AllerFilsPremier(stf))->ObjX));pstf->ObjX = NULL;aTree->Effacer();
                pObjxg = (XMObjectX *)GetResult(ON_RUNNING, TOP_CAST, ((XMObjectX *)&wh), pObjxd);
		pStree->ObjX = (SObjectX *)(pObjxg = Get_XMObjectX(pStree->Nom)?pObjxg->XEval(k,((XMWhole *)pObjxg)->Get()):new XMHead(pStree->Nom,((XMWhole *)pObjxg)->Get()));
		return (void *)(pReponse);
        }
        pStree->ObjX = (SObjectX*)MakeObjectX(pObjx = MakeObjectXFromStree(pStree), pentete, aTree->EstTete() && pentete);
        delete pObjx;
        return (void *)(pReponse);
}

XMObjectX *MakeObjectX(SObjectX *obj, SObjectX *pentete, int flag)
{
        XMObjectX *pmobj = NULL;
        char *Nom = NULL, **Var=NULL;
	char *achar;
        if (flag)
        {
                Nom = pentete->Nom;
                pentete->Nom = NULL;
                Var = ((char **)pentete->ObjX);
                for (int i=0; Var[i]; i++) XMTRACE("Variables N %d	%s\n", i, Var[i]);
                XMTRACE("----------------- %s ----------------\n",Nom);
                pentete->ObjX = NULL;
        }
        switch(obj->Type())
        {
                case TO_FONCTION:
                	pmobj = MakeFonction((char *)obj->ObjX, Nom, Var,NULL);
                	break;
                case TO_MATRICE:
                	pmobj = MakeMatrice((XMWhole *)(obj->ObjX), Nom, Var,NULL);
                	break;
                case TO_KEYWORD:
                case TO_VARIABLE:
                	pmobj = MakeVariable((char *)obj->ObjX,(achar = Copie(0,strlen((char *)obj->ObjX),(char *)obj->ObjX)) ,NULL, NULL);
                	delete achar;
                	break;
                case TO_VECTEUR:
                	pmobj = MakeVecteur((CList<XMObjectX *> *)(obj->ObjX), Nom, Var,NULL);
                	break;
                case TO_PLOT:
                	pmobj = MakePlot((XMWhole *)(obj->ObjX), Nom, NULL,NULL);
                	break;
                case TO_INTERVALLE:
                	pmobj = MakeIntervalle((CList<XMObjectX *> *)(obj->ObjX), Nom, Var,NULL);
                	break;
                case TO_WHOLE:
                 	pmobj = MakeWhole((CList<XMObjectX *> *)(obj->ObjX), Nom, Var,NULL);
                 	break;
                 case TO_HEAD:
                 	pmobj = MakeHead((CList<XMObjectX *> *)(obj->ObjX), obj->Nom, Var,NULL);
                 	break;
                default:
                	XMTRACE("Pas d'objet cree!!!\n");
                	pmobj = NULL;
        }
        return pmobj;
}

void *MakeReponse(int id_client, ArbreM<STree> *aTree)
{
        XMTRACE("*** Debut de MakeReponse ***\n");
        STree *pStree;
        CReponse *pReponse=NULL;
        pStree = aTree->GetPElementCourant();
        pReponse = new CReponse(TR_OK, (void*)((XMObjectX*)pStree->ObjX));
	AddIntoMemory(id_client, ((XMObjectX*)pStree->ObjX));
        XMTRACE("*** Fin de MakeReponse ***\n");
        pStree->ObjX = NULL;
        return (void*)(pReponse);
}

void FoncDest(STree &stree)
{
        if (stree.Nom) delete stree.Nom;
        if (stree.ObjX) ReleaseObjectX(stree.ObjX);
        stree.ObjX = NULL;
        stree.Nom = NULL;
}

void FoncCop(STree &Stree1, STree &Stree2)
{
        Stree1.Nom=Copie(0,strlen(Stree2.Nom),Stree2.Nom);
        Stree1.mType=Stree2.mType;
        Stree1.Type=Stree2.Type;
}

void FoncAff(STree &stree)
{
        XMTRACE("On est sur:
        Nom	Type	TypeSup		Type en char
        %s	%d	%d		%s\n",stree.Nom,stree.mType,stree.Type,GetCharOf((TOperator)stree.mType));
}

void ReleaseObjectX(SObjectX *&Obj)
{
        XMTRACE("*** Debut de release objectx ***\n");
        switch (Obj->mType)
       	{
       	        case TO_FONCTION:
       	        	XMTRACE("*** Object Fonction  dtruire ***\n");
       	        	delete ((XMFonction *)Obj->ObjX);
       	        	XMTRACE("*** Object Fonction dtruit ***\n");
       	        	break;
       	        case TO_MATRICE:
       	        	XMTRACE("*** Object Matrice  dtruire ***\n");
       	        	delete ((XMMatrice *)Obj->ObjX);
       	        	XMTRACE("*** Object Matrice dtruit ***\n");
       	        	break;
       	        case TO_POLYNOME:
       	        	delete ((XMMatrice *)Obj->ObjX);
       	        	break;
       	        case TO_UNKNOWN:
       	        	delete (Obj->ObjX);
       	        	break;
       	}       	        	
       	if (Obj->Nom) delete Obj->Nom;
       	Obj->Nom = NULL;
       	Obj->ObjX = NULL;
       	delete Obj;
       	XMTRACE("*** Fin de release objectx ***\n");
}

void ReleaseInstruction(Instruction *Inst)
{
        if (Inst->CBrut) delete Inst->CBrut;
        if (Inst->aTree) delete ((ArbreM<STree> *)(Inst->aTree));
        if (Inst->aEntete) ReleaseObjectX((SObjectX *&)Inst->aEntete);
        Inst->CBrut = NULL;
        Inst->aTree = NULL;
        Inst->aEntete = NULL;
}


int SayAvancement(int NbreTentative, int id_client, int port, char *namestep, int step, int nbrestep, int inst, int nbreinst)
{
	if (gEstOccupe) return 0;
	gEstOccupe++;
	XMReponse *aReponse;
	int n=0;
	aReponse = new XMReponse;
	aReponse->IDClient = id_client;
	aReponse->IDReponse = XMRAVANCEMENT;
	sprintf(aReponse->Reponse, "%d#%s#%d#%d#%d#%d#", XMRAVANCEMENT, namestep, step, nbrestep, inst, nbreinst);
	for (int k=0; ((n=write(port, aReponse, sizeof(XMReponse))) == -1) && (k<NbreTentative); k++);
	delete aReponse;gEstOccupe--;	
	return n;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//			Definition de la class CAssistant		    //
//////////////////////////////////////////////////////////////////////////////
CAssistant::CAssistant()
{
        Input=NULL;
        MainFile=NULL;
        mIDClient=mIDWrite=0;
        //TempFile = NULL;
}

CAssistant::CAssistant(CAssistant &assistant)
{
        if (assistant.Input)
        {
                int n=strlen(assistant.Input);
        	Input=Copie(0,n,assistant.Input);
        } else Input=NULL;
        if (assistant.MainFile) MainFile=new CFile<Instruction>(*assistant.MainFile);
        	else MainFile=NULL;
        //TempFile = NULL;
}

CReponse *CAssistant::Erreur()
{
        CReponse *Rep = 0;
        int Npo, Npf,iBuff,i,j,Long;

        j=Npf=Npo=0;
        Long=strlen(Input);
        iBuff=Compte(Input,';');

        if ((iBuff!=1) || (Input[Long-1]!=';'))
        {
                if (iBuff>1) Rep=new CReponse(TR_ERROR,Input,E_2PTATTENDU,PositionChar(';',Input)); else
                	Rep=new CReponse(TR_ERROR,Input,E_PTVATTENDU,Long-2);
                return Rep;
        }
        for(i=0;Input[i]!=';';i++)
        {
                if (Input[i]=='(')
                {
                        j=i;
                        Npo++;
                }
                if (Input[i]==')')
                {
                        j=i;
                        Npf++;
                }
                if (Npf>Npo) break;
        }
        if (Npo-Npf)
        {
                if (Npo>Npf) Rep=new CReponse(TR_ERROR,Input,E_PARODETROP,j); else
                	Rep=new CReponse(TR_ERROR,Input,E_PARFDETROP,j-1);
                return Rep;
        }
        return Rep;
}

void CAssistant::SetInput(char *Exp)
{
        Input = Copie(0, strlen(Exp), Exp);
}

void *CAssistant::ErreurComplete()
{
        return 0;
}

void LectureFile(CFile <Instruction> *pf)
{
        Instruction *Instr;
        int k= 0;
        XMTRACE("\nRang	Type	Inst[0]		Inst[1]		Inst[2]\n");
        pf->InitNP();
        while (!pf->VideNP())
        {
                pf->DefilerNP(Instr);
                XMTRACE("%d	%d	%s		%s		%s\n",
                	k,Instr->Type,Instr->CBrut);
                k++;
        }
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//			Entrer ou appel  l'assistant							     //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
void *CAssistant::AppelerAssistant(char *calldata, int id_client, int port)////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
{
        if (!strlen(calldata)) return 0;
        XMTRACE("\n*** Debut de AppelerAssistant ***\n");

        Instruction Inst;
        CFile <CReponse *> *fReponse;
        CReponse *Rep;
        int n;

        fReponse = NULL;
        SetInput(calldata);

        XMTRACE("Entree a executer: '%s'\n", Input);

	mIDClient = id_client;	mIDWrite = port;
	
	n=Compte(Input, ':');
        if (!(Rep = Erreur()))
        {
        	MainFile = new CFile<Instruction>;
        	SayAvancement(10, mIDClient, mIDWrite, "Rception", 0, 4, 0, n+1);
        	Receptionneur();
        	//fReponse = (CFile <CReponse *> *)ErreurComplete();
                if (!fReponse) fReponse = (CFile <CReponse *> *)AnalyserType();
                if (!fReponse) fReponse = (CFile <CReponse *> *)Compilation();
                if (!fReponse) fReponse = (CFile <CReponse *> *)GenerationObjectX();
        } else {fReponse = new CFile <CReponse *>; fReponse->Enfiler(Rep);/*mAvancement->NStatement() = mAvancement->Stage() = 1;*/}
        ReleaseAndInitAll();
        XMTRACE("\n*** Fin de AppelerAssistant ***\n");
        //SayAvancement(10, mIDClient, mIDWrite, "", 3, 4, n, n+1);
        return ((void*)fReponse);
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void CAssistant::ReleaseAndInitAll()
{
        Instruction Inst;

        XMTRACE("*** Debut de ReleaseAll ***\n");
        if (Input) delete Input;
	if (MainFile) ViderMainFile();
	//if (TempFile) delete TempFile;
	XMTRACE("*** Debut de la suppression des tables ***\n");
	XMTRACE("Rien n'a t fait\n");
	//for (int i=BEGINOFTAB; i<ENDOFTAB; i++) RemoveTABOperator((TOperator)i);
	XMTRACE("*** Fin de la suppression des tables ***\n");
       	Input=NULL;
       	MainFile=NULL;
    	//TempFile = NULL;
       	XMTRACE("*** Fin de ReleaseAll ***\n");
}

void CAssistant::InitTete(ArbreM<STree> *aTree)
{
        STree Stree;
        Stree.Nom = Copie(0,1,"(");
        Stree.ObjX = NULL;
        aTree->Ajouter(Stree);
}

void CAssistant::InitArbre(ArbreM<STree> *aTree, void (*pd)(STree &), void (*pc)(STree &, STree &), void (*pa)(STree &))
{
        aTree->Init(pd);
        aTree->InitCopie(pc);
        aTree->InitAffiche(pa);
}

void *CAssistant::CreerType(Instruction *Inst)
{
        Inst->aTree = (ArbreM<STree> *)(Arbrer(Inst->CBrut));
     	return 0;
}

void *CAssistant::Arbrer(char *Exp)
{
        int i,n;
        char *Expression, *S[1];
        ArbreM<STree> *aTree;

        STree Stree;
        int Op,Pos;

        Expression = Copie(0, strlen(Exp), Exp);
        aTree = new ArbreM<STree>;
        InitTete(aTree);
        InitArbre(aTree,&FoncDest,&FoncCop,&FoncAff);
        Decompress(Expression,S);
        Stree.Nom = S[0];
        Stree.mType = (TObjectX)GetTypeObjetX(S[0]);
        Stree.ObjX = NULL;
        aTree->Ajouter(Stree);
        while (Expression[0]!=';')
        {
                Decompress(Expression,S);
                if ((Op=EstOperateur(S[0]))>0)
                {
                	if (Op==2) Permuter(aTree, S[0]); else Supprimer(aTree,InvOp(S[0]));
                } else
                {
                	Stree.Nom = S[0];
                	Stree.mType = (TObjectX)GetTypeObjetX(S[0]);
               	        Stree.ObjX = NULL;
                	aTree->Ajouter(Stree);
                }
        }
        aTree->SupprimerTete();
        delete Expression;
        return (void *)(aTree);
}

void *CAssistant::DeArbrer(ArbreM<STree> *aTree, void *(*TraiterArbre)(ArbreM<STree> *aTree, SObjectX *pobjx), void *(*makeReponse)(int , ArbreM<STree> *) =NULL, SObjectX *entete=NULL)
{
        if (!aTree) return 0;
        void* pReponse;
        pReponse = NULL;
        if (aTree->ExisteTete())
        {
                STree Stree;
                aTree->AllerTete(Stree);
                if (aTree->ExisteFils())
                {
                        aTree->AllerFilsPremier(Stree);
                        while (!aTree->FinFrere())
                        {
                                DeArbrerBis(aTree, TraiterArbre);
                                aTree->AllerFrereSuivant(Stree);
                        }
                        aTree->AllerPere(Stree);
               	}
               	(*TraiterArbre)(aTree, entete);
               	if (makeReponse) pReponse = (*makeReponse)(mIDClient, aTree);
               	return pReponse;               	
        }
}

void *CAssistant::DeArbrerBis(ArbreM<STree> *aTree, void *(*TraiterArbre)(ArbreM<STree> *aTree, SObjectX *pobjx=NULL), SObjectX *pobjx=NULL)
{
        if (aTree->ExisteFils())
        {
                STree Stree;
                aTree->AllerFilsPremier(Stree);
                while (!aTree->FinFrere())
                {
                        DeArbrerBis(aTree, TraiterArbre);
                        aTree->AllerFrereSuivant(Stree);
                }aTree->AllerPere(Stree);
                /*
                	Modif du 17/07/99
                 	return (*TraiterArbre)(aTree,pobjx);
                */

        }
        return (*TraiterArbre)(aTree,pobjx);
}

void CAssistant::Lecture(ArbreM<STree> *aTree)
{
        if (aTree) aTree->Parcourir();
}


void CAssistant::ViderMainFile()
{
        Instruction Inst;
        int i=0;
        while (!MainFile->Vide())
        {
                XMTRACE("*** Vidange N %d ***\n",i);
                MainFile->Defiler(Inst);
                ReleaseInstruction(&Inst);
                XMTRACE("*** Fin vidange N %d ***\n",i);
                i++;
        }
        delete MainFile;
}

void CAssistant::Permuter(ArbreM<STree> *aTree, char *Exp)
{
	char *Res,*Tmp;
        STree Stree;
        int n, p1, p2;
        aTree->ElementCourant(Stree);
        while ((p1=Priorite(Stree.Nom))>(p2=Priorite(Exp))) aTree->AllerPere(Stree);
        if ((Stree.Nom[0]==',') && (Exp[0]==',')) return;
        aTree->AllerFilsDernier(Stree);
        Stree.mType = (TObjectX)GetTypeObjetX(Exp);
        Stree.Nom = Exp;
        aTree->Inserer(Stree);
}

void CAssistant::Supprimer(ArbreM<STree> *aTree, char *Exp)
{
	STree Stree, *pStree;
        aTree->ElementCourant(Stree);
        while (strcmp(Exp,Stree.Nom)) aTree->AllerPere(Stree);
        aTree->Supprimer();
	if (pStree = aTree->GetFils(Stree)) pStree->Type =  DelimitToTObjectX(Exp);
}

void AfficherPtr(char *Exp, void *Ptr)
{
        XMTRACE("======   %s: %p   =====\n",Exp,Ptr);
}

/*int SaveXMObjectX(void *obj)
{
	XMObjectX *objx = (XMObjectX *)obj;
	if (!obj) return 0;
	CFile <XMObjectX *> *fObjx;
	if (!TempFile) fObjx = new CFile<XMObjectX *>; else fObjx = (CFile <XMObjectX *> *)(TempFile);
	fObjx->Enfiler((XMObjectX *)obj);
	TempFile = (CFile <void *> *)fObjx;
	return 1;
}

//XMObjectX GetXMObjectX();

void CAssistant::Fusion(void *reps)
{
	if (!TempFile) return;
	XMObjectX *obj;
	CFile <CReponse *> *frep = (reps?(CFile <CReponse *> *)reps:new CFile <CReponse *>);
	CFile <XMObjectX *> *fObjx = (CFile <XMObjectX *> *)TempFile;
	while (!fObjx->Vide())
        {
                fObjx->Defiler(obj);
                frep->Enfiler(new CReponse(TR_OK, obj));
        }
        delete ((CFile <XMObjectX *> *)TempFile);
        TempFile = NULL;
}*/

void CAssistant::Receptionneur()
{
        Instruction Instruc;
        char *Buff;
        int i=0;
        int n = Compte(Input,':');

	Instruc.Type = TO_INIT;
        if (Compte(Input,';')>Compte(Input,':')) Buff=GetIntervalle(Input,';'); else
        	Buff=GetIntervalle(Input,':');
        do
        {
        	printf("================    RECEPTION    ============= [%d:%d]\n", i, n);
        	
        	SayAvancement(10, mIDClient, mIDWrite, "Rception", 0, 4, ++i, n+1);
        	Concatener(&Buff,";");
        	Instruc.CBrut = Buff;
                Instruc.aEntete = Instruc.aTree = 0;
                Decallage(1,Input);
                MainFile->Enfiler(Instruc);
		if (Compte(Input,';')>Compte(Input,':')) Buff=GetIntervalle(Input,';'); else
        		Buff=GetIntervalle(Input,':');
        }
        while (Buff);
}

void *CAssistant::AnalyserType()
{
      	CFile <CReponse*> *fReponse = 0;
	CReponse *pReponse;
	Instruction *Inst;
	int i=-1;
        int n = MainFile->Occurrence();
	
	XMTRACE("*** Debut de analyser du type ***\n");
	XMTRACE("Type			CBrut\n");
	XMTRACE("=============================\n");
	MainFile->InitNP();
        SayAvancement(10, mIDClient, mIDWrite, "Analyse du script", 1, 4, 0, n);
	while (!MainFile->VideNP())
        {
        	printf("================    ANALYSER_TYPE    ============= [%d]\n", i);
                MainFile->DefilerNP(Inst);
        	SayAvancement(10, mIDClient, mIDWrite, "Analyse du script", 1, 4, ++i, n);
        	XMTRACE("%d			%s\n",Inst->Type,Inst->CBrut);
                if (pReponse = (CReponse *)CreerType(Inst))
                {
                        if (!fReponse) fReponse = new CFile<CReponse*>;
                        fReponse->Enfiler(pReponse);
                }
                //Lecture(((ArbreM<STree>*)Inst->aTree));
        }
        XMTRACE("\n*** Fin de l'analyse du type ***\n");
        return (void *)fReponse;
}


void *CAssistant::Compilation()
{
        Instruction *Inst;
        CReponse *aReponse;
        CFile <CReponse *> *fReponse;
        int i=-1;
        int n = MainFile->Occurrence();
        fReponse = NULL;

        XMTRACE("*** Debut de la compilation ***\n");
        InitTAB(ON_COMPILE);
        MainFile->InitNP();
        SayAvancement(10, mIDClient, mIDWrite, "Compilation", 2, 4, 0, n);
        while (!MainFile->VideNP())
        {
              XMTRACE("*** Compilation %d ***\n",i);
              MainFile->DefilerNP(Inst);
              SayAvancement(10, mIDClient, mIDWrite, "Compilation", 2, 4, ++i, n);
              aReponse = (CReponse *)DeArbrer((ArbreM<STree>*)Inst->aTree, Compiler);
              if (aReponse)
              {
                	if (!fReponse) fReponse = new CFile <CReponse *>;
                	fReponse->Enfiler(aReponse);
              } else
              {
                //Lecture(((ArbreM<STree>*)Inst->aTree));
                XMTRACE("*** Compilation realiser avec succes!!!! ****\n");
              }
        }
        XMTRACE("*** Fin de la compilation ***\n");
        //Fusion(fReponse);
        return ((void *)(fReponse));
}

void *CAssistant::GenerationObjectX()
{
        CFile <CReponse *> *fReponse;
        CReponse *aReponse;
        Instruction Inst;
        int n = MainFile->Occurrence();
        int i=-1;
	XMTRACE("*** Dbut de la gnration des objects ***\n");
        fReponse = new CFile <CReponse *>;
        InitTAB(ON_RUNNING);
        SayAvancement(10, mIDClient, mIDWrite, "Gnration", 3, 4, 0, n);
        while (!MainFile->Vide())
        {
                MainFile->Defiler(Inst);
                SayAvancement(10, mIDClient, mIDWrite, "Gnration", 3, 4, ++i, n);
                fReponse->Enfiler(aReponse = (CReponse*)DeArbrer((ArbreM<STree>*)Inst.aTree, GenererObjectX, MakeReponse,(SObjectX*)Inst.aEntete));
                XMTRACE("Gestion::Generer[%p]\n",((XMPlot *)(aReponse->ObjX))->Syscoord());
                //((ArbreM<STree>*)Inst.aTree)->Parcourir();
                ReleaseInstruction(&Inst);
        }
        XMTRACE("*** Fin de la gnration ***\n");
        for(double k=0; k<5000; k++);
        printf("[FIN]\n");
        return ((void *)(fReponse));
}

CAssistant::~CAssistant()
{
        ReleaseAndInitAll();
}


/***********************************************************************************/
/******************		Definition des tables		********************/
/***********************************************************************************/

template <class T> T* SommeVV(OnState st, T* objg, T* objd)
{
        XMTRACE("*** Debut de SommeVV ***\n");
        T *t=NULL;
        if (st == ON_COMPILE)
        {
        	SObjectX *obj; char *res;
        	obj = new SObjectX;
        	obj->Nom = NULL;
        	res = new char[strlen((char*)objg->ObjectX())+1+strlen((char*)objd->ObjectX())+1];
        	sprintf(res,"%s+%s",(char*)objg->ObjectX(),(char*)objd->ObjectX());
        	obj->ObjectX() = (void *)res;
        	t=(T*)obj;
        }
        if (st == ON_RUNNING)
        {
        }
        return t;
}

template <class T> void InitTABPlus(OnState st, T*)
{
        SetCalculator(st, TOP_PLUS, TO_VARIABLE, TO_VARIABLE, new CCalculator<T>(TO_FONCTION, SommeVV));
        SetCalculator(st, TOP_PLUS, TO_FONCTION, TO_FONCTION, new CCalculator<T>(TO_FONCTION, SommeVV));
        SetCalculator(st, TOP_PLUS, TO_VECTEUR, TO_VECTEUR, new CCalculator<T>(TO_VECTEUR, SommeVV));
        SetCalculator(st, TOP_PLUS, TO_INTERVALLE, TO_INTERVALLE, new CCalculator<T>(TO_INTERVALLE, SommeVV));
}

template <class T> T* SinF(OnState st, T* objg, T* objd)
{
        XMTRACE("*** Debut de SinF ***\n");
        T *t=NULL;
        if (st == ON_COMPILE)
        {
	        SObjectX *obj; char *res;
	        obj = new SObjectX;
	        obj->Nom = NULL;
	        res = new char[strlen("sin(")+strlen((char*)objd->ObjectX())+strlen(")")+1];
	        sprintf(res,"sin(%s)",(char*)objd->ObjectX());
	        obj->ObjX = (void *)res;
	        t=(T*)obj;
	}
	if (st == ON_RUNNING)
        {
        }
        return t;
}

template <class T> T* SinV(OnState st, T* objg, T* objd)
{
        XMTRACE("*** Debut de SinF ***\n");
        T *t=NULL;
        if (st == ON_COMPILE)
        {
	        SObjectX *obj; char *res;
	        obj = new SObjectX;
	        obj->Nom = NULL;
	        res = new char[strlen("sin(")+strlen((char*)objd->ObjectX())+strlen(")")+1];
	        sprintf(res,"sin(%s)",(char*)objd->ObjectX());
	        obj->ObjX = (void *)res;
	        t=(T*)obj;
	}
	if (st == ON_RUNNING)
        {
        }
        return t;
}

template <class T> void InitTABTrigo(OnState st, T*)
{
        SetCalculator(st, TOP_TRIGO, TO_INIT, TO_FONCTION, new CCalculator<SObjectX>(TO_FONCTION, SinF));
        SetCalculator(st, TOP_TRIGO, TO_INIT, TO_VARIABLE, new CCalculator<SObjectX>(TO_FONCTION, SinF));
        SetCalculator(st, TOP_TRIGO, TO_INIT, TO_VECTEUR, new CCalculator<SObjectX>(TO_FONCTION, SinV));
}

template <class T> T* EgalVI(OnState st, T* objg, T* objd)
{
        T *t=NULL;
        if (st == ON_COMPILE)
        {
	}
	if (st == ON_RUNNING)
        {
        	XMObjectX *obj=(XMObjectX *)objd;
        	XMObjectX *obg = (XMObjectX *)objg;
        	obj->SetName(obg->GetName());
		obj->ObjectX() = obj;
        	t = (T *)obj;
        }
        return t;
}

template <class T> T* EgalHF(OnState st, T* objg, T* objd)
{
        T *t=NULL;
        if (st == ON_COMPILE)
        {
	}
	if (st == ON_RUNNING)
        {
        	XMObjectX *obj=(XMObjectX *)objd;
		char *res;
		obj->SetName(((XMObjectX *)objg)->GetName());
		obj->AddVariables((CList <XMObjectX *> *)(((XMObjectX *)objg)->Variables()));
        	obj->ObjectX() = obj;
        	t = (T *)obj;
        }
        return t;
}

template <class T> void InitTABEgal(OnState st, T*)
{
        SetCalculator(st, TOP_EGAL, TO_HEAD, TO_INTERVALLE, new CCalculator<SObjectX>(TO_INTERVALLE, EgalVI));
        SetCalculator(st, TOP_EGAL, TO_HEAD, TO_VARIABLE, new CCalculator<SObjectX>(TO_FONCTION, EgalHF));
        SetCalculator(st, TOP_EGAL, TO_HEAD, TO_FONCTION, new CCalculator<SObjectX>(TO_FONCTION, EgalVI));
        SetCalculator(st, TOP_EGAL, TO_HEAD, TO_VECTEUR, new CCalculator<SObjectX>(TO_VECTEUR, EgalVI));
        SetCalculator(st, TOP_EGAL, TO_HEAD, TO_MATRICE, new CCalculator<SObjectX>(TO_MATRICE, EgalVI));
	SetCalculator(st, TOP_EGAL, TO_HEAD, TO_WHOLE, new CCalculator<SObjectX>(TO_WHOLE, EgalVI));
	SetCalculator(st, TOP_EGAL, TO_HEAD, TO_FONCTION, new CCalculator<SObjectX>(TO_FONCTION, EgalHF));
	SetCalculator(st, TOP_EGAL, TO_VARIABLE, TO_INTERVALLE, new CCalculator<SObjectX>(TO_INTERVALLE, EgalVI));
	SetCalculator(st, TOP_EGAL, TO_VARIABLE, TO_VARIABLE, new CCalculator<SObjectX>(TO_VARIABLE, EgalVI));
	SetCalculator(st, TOP_EGAL, TO_VARIABLE, TO_FONCTION, new CCalculator<SObjectX>(TO_FONCTION, EgalVI));
	SetCalculator(st, TOP_EGAL, TO_VARIABLE, TO_VECTEUR, new CCalculator<SObjectX>(TO_VECTEUR, EgalVI));
        SetCalculator(st, TOP_EGAL, TO_VARIABLE, TO_MATRICE, new CCalculator<SObjectX>(TO_MATRICE, EgalVI));
	SetCalculator(st, TOP_EGAL, TO_VARIABLE, TO_WHOLE, new CCalculator<SObjectX>(TO_WHOLE, EgalVI));
}

template <class T> T* CastWW(OnState st, T* objg, T* objd)
{
	T *t=NULL;
        if (st == ON_COMPILE)
        {
	}
	if (st == ON_RUNNING)
        {
        	t = (T *)objd;
        }
        return t;
}

template <class T> T* CastWV(OnState st, T* objg, T* objd)
{
	T *t=NULL;
        if (st == ON_COMPILE)
        {
	}
	if (st == ON_RUNNING)
        {
        	XMWhole *wh = new XMWhole;
        	wh->Add((XMObjectX *)objd);
        	t = (T *)wh;
        }
        return t;
}

template <class T> void InitTABCast(OnState st, T*)
{
        SetCalculator(st, TOP_CAST, TO_WHOLE, TO_WHOLE, new CCalculator<SObjectX>(TO_WHOLE, CastWW));
	SetCalculator(st, TOP_CAST, TO_WHOLE, TO_VARIABLE, new CCalculator<SObjectX>(TO_WHOLE, CastWV));
}
