 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: gestionobjx.h,v 1.2 2000/11/02 22:10:22 daville Exp $
 * $Log: gestionobjx.h,v $
 * Revision 1.2  2000/11/02 22:10:22  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef GESTIONOBJX_H
#define GESTIONOBJX_H
#include "reponse.h"
#include "type.h"
#include "Containers.h"

int SaveXMObjectX(void *obj);
class CAssistant
{
        private:
        	int mIDClient, mIDWrite;
        	char *Input;
        	CFile<Instruction> *MainFile;
        	//CFile<void *> *TempFile;
        public:
        	CAssistant();
        	CAssistant(CAssistant &assistant);
        	void Init();
        	void InitTete(ArbreM<STree> *aTree);
        	void InitExec(int end);
        	void InitArbre(ArbreM<STree> *aTree, void (*pd)(STree &), void (*pc)(STree &, STree &), void (*pa)(STree &));
        	
        	int SayAvance(int k, int stape=0, char *name=NULL);
	//friend	int SaveXMObjectX(void *obj);
	//friend 	XMObjectX *Get_XMObjectX(char *name);
        //	void Fusion(void *ptr);
        	void SetInput(char *Exp);
        	void Receptionneur();
        	CReponse *Erreur(); 
        	void *ErreurComplete();
        	void *EtablirEntete();
                void *CreationEntete();
                void *GenerationEntete();
                void *AnalyserType();
        	void *Compilation();
        	void *GenerationObjectX();
        	void *CreerType(Instruction *Inst);
                void *AppelerAssistant(char *calldata, int id_user, int port);
        	
        	void *Arbrer(char *Exp);
        	void *DeArbrer(ArbreM<STree> *aTree, void* (*TraiterArbre)(ArbreM<STree> *, SObjectX *pojx), void *(*makeReponse)(int , ArbreM<STree> *) = NULL, SObjectX *entete = NULL);
        	void *DeArbrerBis(ArbreM<STree> *aTree, void* (*TraiterArbre)(ArbreM<STree> *, SObjectX *pojx), SObjectX *pobjx=NULL);
        	void Lecture(ArbreM<STree> *aTree);
        	void Permuter(ArbreM<STree> *aTree, char *Exp);
        	void Supprimer(ArbreM<STree> *aTree, char *Exp);
        	
        	void ReleaseAndInitAll();
        	void ViderMainFile();
        	~CAssistant();
};

void ReleaseObjectX(SObjectX *&obj);
void ReleaseInstruction(Instruction *Inst);

int Done(char *S);
void RenvoyerEtat(char **Expo, char *Exp);
int EstCommande(char *Exp);
#endif
