 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: loi.cpp,v 1.2 2000/11/02 22:10:22 daville Exp $
 * $Log: loi.cpp,v $
 * Revision 1.2  2000/11/02 22:10:22  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <stdio.h>
#include "loi.h"
#include "mobjectx.h"

void *GetTAB(OnState st=ON_COMPILE)
{
	return MAINTABOP[st];
}

void InitMainTab(OnState st=ON_COMPILE)
{
	typedef XMObjectX XY;
	if (st == ON_COMPILE) typedef SObjectX XY;
        for (int i=BEGINOFTAB; i<ENDOFTAB; i++)  ((CCalculator<XY> ****)MAINTABOP[st])[i-OFFSET] = NULL;
}

TObjectX GetTypeOBjectX(OnState st, TOperator op, TObjectX lig, TObjectX col)
{
	typedef XMObjectX XY;
	if (st == ON_COMPILE) typedef SObjectX XY; else typedef XMObjectX XY;
	return ((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET][col][lig]->GetTypeObject();
}

void CreateTABOperator(OnState st, TOperator op)
{
	int i,j;
	typedef XMObjectX XY;
	if (st == ON_COMPILE) typedef SObjectX XY;
	CCalculator<XY> ***aTab = new (CCalculator<XY> **)[DIM_TAB];
	for(i=0;i<DIM_TAB;i++) aTab[i] = new (CCalculator<XY> *)[DIM_TAB];
	for(j=0;j<DIM_TAB;j++) for(int i=0;i<DIM_TAB;i++) aTab[j][i] = NULL;
	((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET] = aTab;
        for(j=0;j<DIM_TAB; j++) for(i = 0; i<DIM_TAB; i++)	((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET][j][i] = NULL;
}

void RemoveCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col)
{
	typedef XMObjectX XY;
	if (st == ON_COMPILE) typedef SObjectX XY;
        if (((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET])
        {
        	if (((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET][col][lig])
        	       delete (((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET][col][lig]);
        }
        ((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET][col][lig] = NULL;
}

void RemoveTABOperator(OnState st, TOperator op)
{
        typedef XMObjectX XY;
	if (st == ON_COMPILE) typedef SObjectX XY;
        if (((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET])
        {
                int i;
                for (int j = 0; j<DIM_TAB; j++)
                	for (i=0; i<DIM_TAB; i++)
                		RemoveCalculator(st, op,(TObjectX)i,(TObjectX)j);
                delete (((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET]);
        	((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET] = NULL;
        }
}