 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: map.cpp,v 1.2 2000/11/02 22:10:08 daville Exp $
 * $Log: map.cpp,v $
 * Revision 1.2  2000/11/02 22:10:08  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include "map.h"

void XMMap::Add(TYPE *pt)
{
	if (!mDepth) return;
	TYPE *p = new TYPE[mDepth];
	for(int i=0; i<mDepth; i++) p[i]=pt[i];
	if (!mTBPoint) mTBPoint = new CList<TYPE *>;
	mTBPoint->Add(p);
}


XMMap::XMMap()
{
	mDepth = 0;
	mTBPoint = NULL;
}

XMMap::XMMap(XMMap &map)
{
	mDepth = map.mDepth;
	mTBPoint = ((mTBPoint)? new CList<TYPE *>((*map.mTBPoint)): NULL);
}

XMMap::XMMap(int dep)
{
	SetDepth(dep);
}
void XMMap::SetDepth(int dep)
{
	if (dep<=0) return;
	++mDepth=dep;
	mTBPoint = new CList<TYPE *>;
}

int XMMap::Depth()
{
	return mDepth;
}

int XMMap::SetPoint(int k, int dep, TYPE  val)
{
	TYPE *p;
	if (!(p=mTBPoint->Get(k))) return 0;
	return (int)(p[dep]=val);
}

int XMMap::GetPoint(int k, TYPE* & val)
{
	printf("Valeur de mTBPoint: %p\n",mTBPoint);
	if (!mTBPoint) return 0;
	printf("Test de mTBPoint: %d : %d\n",mTBPoint->GetCount(),k);
	if (mTBPoint->GetCount()<k) return 0;
	val=mTBPoint->Get(k);
	return 1;
}

int XMMap::GetPoint(int k, int dep, TYPE &val)
{
	TYPE *p;
	if (!(p=mTBPoint->Get(k))) return 0;
	return (int)(val=p[dep]);
}