 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: math.cpp,v 1.2 2000/11/02 22:10:08 daville Exp $
 * $Log: math.cpp,v $
 * Revision 1.2  2000/11/02 22:10:08  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <string.h>
#include <math.h>
#include <stdlib.h>
#include "ArbreM.h"
#include "Liste.h"
#include "type.h"
#include "number.h"
#include "fonction.h"
#include "chaine.h"
#include "math.h" 
#include "regle.h"
#include "utils.h"
#include <stdio.h>

void Entre(char *s)
{
        XMTRACE("\n*********    Appel de la fonction %s    *********\n",s);
}

void Quit(char *s)
{
        XMTRACE("\n********    Sortie de la fonction %s    ******\n",s);
} 


Element::Element()
{
        Nom=Vals=Vald=NULL;
        Val=0.0;
}

void ECopie(Element &E1, Element &E2)
{
        E1.Nom=new char [strlen(E2.Nom)+1];
        strcpy(E1.Nom,E2.Nom);
        if (E2.Vals)
        {
                E1.Vals=new char [strlen(E2.Vals)+1];
                strcpy(E1.Vals,E2.Vals);
        } else E1.Vals=NULL;
        if (E2.Vald)
        {
                E1.Vald=new char [strlen(E2.Vald)+1];
                strcpy(E1.Vald,E2.Vald);
        } else E1.Vald=NULL;
        E1.Val=E2.Val;
}

void AffElt(Element &elt)
{
        XMTRACE("On est sur: %s\n", elt.Nom);
}

void DestrucForCall(Element &Elt)
{ 
       // XMTRACE("Ok\n");
        if (Elt.Nom)  delete(Elt.Nom);
        if (Elt.Vals) delete(Elt.Vals);
        if (Elt.Vald) delete(Elt.Vald);
} 
    
XMFonction::XMFonction()
{
        mName = mExpression[0] = mExpression[1] = NULL;
        Res = 0;
        Variables = NULL;
        FONCTIONCALL=(void (*)(Element&))(&DestrucForCall);
        COPIE=(void (*)(Element &, Element &))(&ECopie);
}

XMFonction::XMFonction(XMFonction &fonction):ArbreM<Element>(fonction.mTete,&DestrucForCall,&ECopie)
{
        int i; int g;
        mType = TO_FONCTION;
        // A retouche
        /*if (NbreVar)
        {
                Variables=new (XMVariable *)[NbreVar+1];
        	for (i=0;i<NbreVar;i++)
        	{
            	       Variables[i]->SetName(fonction.Variables[i]->GetName());
             	       Variables[i]->SetValue(fonction.Variables[i]->Eval(g));
                }
                Variables[i]=NULL;
        } else */Variables=NULL;
        if (fonction.mName)
        {
                mName = Copie(0, strlen(fonction.mName), fonction.mName);
        } else mName=NULL;
        for(i=0;i<2;i++) SetExp(i,fonction.mExpression[i]);
        Res= 0;
        FONCTIONCALL=DestrucForCall;
        COPIE=ECopie;
}

XMFonction::XMFonction(char *Exp)
{
        mType = TO_FONCTION;
        SetExp(0,Exp);
        SetExp(1,Exp);
        Variables=NULL;
        FONCTIONCALL=(void (*)(Element&))(&DestrucForCall);
        COPIE=(void (*)(Element &, Element &))(&ECopie);
        if (!mTete) Init();
}

XMFonction::XMFonction(char *nom, char *Exp)
{
        mType = TO_FONCTION;
        if (nom) mName = Copie(0, strlen(nom), nom);
        XMTRACE("Expresion interne\n");
        SetExp(0, Exp);
        XMTRACE("Expresion externe\n");
        SetExp(1, Exp);
        XMTRACE("Expresion in-externe\n");
  	Variables=NULL;
        FONCTIONCALL=(void (*)(Element&))(&DestrucForCall);
        COPIE=(void (*)(Element &, Element &))(&ECopie);
}

XMFonction XMFonction::operator=(XMFonction fonction)
{
        XMFonction F(fonction);
        return F;
}

void Aff(Element &E)
{
        XMTRACE("D'apres la XMFonction on a: %s\n",E.Nom);
}

XMFonction XMFonction::operator+(XMFonction &fonction)
{
        XMFonction F1(*this);
        XMTRACE("<<===============  AVANT LE RETOUR  ============>>\n");
        getchar();
        return F1;
}

XMObjectX *XMFonction::Clone()
{
        return new XMFonction(*this);
}

char *XMFonction::Affiche()
{
        int i, n;
        char *aff;
        n = 0;
        if (!mLVar) i=0; else if (mLVar->GetCount()) i=1;
        n = strlen(mName);
        for(int j=0;Variables[j]; j++) n = n + strlen(Variables[j]->GetName());
        n = n + strlen(mExpression[0]);
        n = n + 2*i; // Pour les parentheses
        //n = n + i*(NbreVar-1); // Pour les virgules sparants les variables
        n = n + 1; 	// Pour gale
        aff = new char[n + 1];
        strcpy(aff, mName);
        if (i)
        {
              strcat(aff, "(");
              strcat(aff, Variables[0]->GetName());
              for (int j= 1; Variables[j]; j++)
              {
                strcat(aff, ",");
                strcat(aff, Variables[0]->GetName());
              }
              strcat(aff, ")");
         }
         strcat(aff,"=");
         strcat(aff, mExpression[i]);
         return aff;
}

void XMFonction::Lecture()
{
	XMTRACE("Type:		XMFonction\n");
        XMTRACE("ID:		%d\n", mType);
        XMTRACE("Nom:		%s\n",mName);
        XMTRACE("Expression int:	%s\n", mExpression[0]);
        XMTRACE("Expression ext: %s\n", mExpression[1]);
        XMTRACE("Nbre variable:	%d\n", NVariables());
        for (int i=0; i<NVariables(); i++) XMTRACE("Variable:	%s\n",mLVar->Get(i)->GetName());
}

void XMFonction::Init()
{
        Entre("Init");
        Element Elt;
        Elt.Nom=new char [2];
        strcpy(Elt.Nom,"(");
        Elt.Vals=NULL;
        Elt.Vald=NULL;
        Elt.Val=0.0;
        Ajouter(Elt);
        Quit("Init");
}

void XMFonction::PutVar(XMVariable *V,int pos)
{
/*        if (pos>NbreVar) return;
        Variables[pos] = V;*/
}

void XMFonction::SetVar(int Dim)
{
        Variables=new (XMVariable *)[Dim+1];
        Variables[Dim]=NULL;
        //NbreVar=Dim;
}

void XMFonction::Ajout(char *s)
{
        Element PE;int c;
        TYPE Val;
        PE.Nom=Copie(0, strlen(s), s);;
        PE.Vals=NULL;
        PE.Vald=NULL;
        strcpy(PE.Nom,s);
        val(s,PE.Val,c);
        Ajouter(PE);
        Element *pelt = (Element *)mCourant->Info;
        XMTRACE("******* Wait *******\n");
        XMTRACE("**** On vient d'ajouter: %s ***\n", pelt->Nom);
}

void XMFonction::Permut(char * s)
{
        SNoeud *PNew;
        Element PE,*Pelt=((Element *)(mCourant->Info));
        Entre("Permut");
        XMTRACE("***  Actuellement on est sur: %s  ***\n", Pelt->Nom);
        while (Priorite(Pelt->Nom)>Priorite(s))
        {
                XMTRACE("*** Dans la boucle while ***\n");
                mCourant=mCourant->Pere;
                Pelt=((Element *)(mCourant->Info));
                XMTRACE("*** Bas de while ***\n");
        }
        XMTRACE("On est stoppe sur: %s\n", Pelt->Nom);
        if ((Pelt->Nom[0]==',') && (s[0]==',')) return;
        AllerFilsDernier(PE);
        XMTRACE("Maintenant on est sur: %s\n",((Element*)mCourant->Info)->Nom);
        PE.Nom=Copie(0, strlen(s), s);
        PE.Vald=NULL;
        PE.Vals=NULL;
        XMTRACE("*** Avant l'insertion ***\n");
        Inserer(PE);
        Quit("Permut");
}

void XMFonction::DelParent()
{
        SNoeud *PNeu;
        while(strcmp(((Element *)(mCourant->Info))->Nom,"(")) mCourant=mCourant->Pere;
    	Supprimer();
}

void XMFonction::FinArbre()
{
        SupprimerTete();
}

void XMFonction::Arbrer()
{
        char *S, *So;
        int i;
        TYPE vale;
        Entre("Arbrer");
     	if (!mExpression[0]) return;
        S = Copie(0, strlen(mExpression[0]),mExpression[0]);
        Decompress(S,&So);
        if (!mTete) Init();
        Ajout(So);
        while (S[0]!=';')
        {
                /*     Convertion de chaine a reel   */
                val(So,vale,i);
                Decompress(S,&So);
                XMTRACE("*** De Decompresse: %s ***\n", So);
                if (!strcmp(So,"("))   Ajout("(") ; else
                if (!strcmp(So,")"))   DelParent(); else
                if ((!strcmp(So,"+")) || (!strcmp(So,"-")) || (!strcmp(So,"*")) ||
                    (!strcmp(So,"/")) || (!strcmp(So,"^")) || (!strcmp(So,","))) Permut(So);
                      else Ajout(So);
                if (So) delete So;
       }
       FinArbre();
       delete (S);
       Quit("Arbrer");
}

TYPE XMFonction::Eval(int &Verite, CList <XMObjectX *> *lvar=NULL)
{
        Res=1;
        mCourant= mTete;
        if (mCourant->PListFils)
        {
                SNoeud *Ptr=mCourant;
                Ptr->PListFils->MoveFirst(mCourant);
                while (!Ptr->PListFils->Eol())
                {
                        Calcul(mCourant,lvar);
                        Ptr->PListFils->MoveNext(mCourant);
                }
                mCourant=Ptr;
        }
        Verite= (Effectuer(mCourant,lvar)) && (Res);
        return ((Element *)(mCourant->Info))->Val;
}

void XMFonction::Calcul(SNoeud *PSNoeu, CList <XMObjectX *> *lvar=NULL)
{
        int v;
        if (PSNoeu->PListFils)
        {
                SNoeud *Ptr;
                PSNoeu->PListFils->MoveFirst(Ptr);
                while (!PSNoeu->PListFils->Eol())
                {
                        Calcul(Ptr, lvar);
                	PSNoeu->PListFils->MoveNext(Ptr);
               	}
        }
        if (!(v= Effectuer(PSNoeu, lvar))) Res=v;
}

XMObjectX *XMFonction::Diff(char *VarDe)
{/*
        mCourant= mTete;
        if (mCourant->Filsd)
        {
                mCourant=mCourant->Filsd;
                Derivate(mCourant,VarDe);
                mCourant=mCourant->Pere;
        }
        if (mCourant->Filsg)
        {
               	mCourant=mCourant->Filsg;
               	Derivate(mCourant,VarDe);
               	mCourant=mCourant->Pere;
        }
        Derivee(mCourant,VarDe,LFonc);
        char *Res[2];
        Res[0]=((Element *)mCourant->Info)->Vald;
        Res[1]=new char[strlen(Res[0])+1];
        strcpy(Res[1],Res[0]);

        char *nom;
        XMFonction *f;
        nom = new char[strlen(mName)+2];
        sprintf(nom, "%s'", mName);
        f = new XMFonction(nom, Res1);
        f->SetVar(NbreVar);
        for (int i=0; i<NbreVar; i++) f->PutVar(Variables[i]->Clone(), i));
        f->Init();
        f->Arbrer();
        return f;*/
}

void XMFonction::Derivate(SNoeud *PSNoeu, char *VarDe)
{/*
        if (PSNoeu->Filsd)
        {
                PSNoeu= PSNoeu->Filsd;
                Derivate(PSNoeu,VarDe,LFonc);
                PSNoeu= PSNoeu->Pere;
        }
        if (PSNoeu->Filsg)
        {
                PSNoeu= PSNoeu->Filsg;
                Derivate(PSNoeu,VarDe,LFonc);
                PSNoeu= PSNoeu->Pere;
        }
        Derivee(PSNoeu,VarDe,LFonc);*/
}

char *XMFonction::EvalF(int &Verite, CList <XMObjectX *> *lvar=NULL)
{/*
        Res=1;
        mCourant= mTete;
        if (mCourant->Filsd)
        {
                mCourant=mCourant->Filsd;
                CalculF(mCourant,LFonc);
                mCourant=mCourant->Pere;
        }
        if (mCourant->Filsg)
        {
               	mCourant=mCourant->Filsg;
               	CalculF(mCourant,LFonc);
               	mCourant=mCourant->Pere;
        }
        EffectuerF(mCourant,Variables,LFonc);
        char *Res[2];
        Res[0]=((Element *)(mCourant->Info))->Vals;
        Res[1]=new char[strlen(Res[0])+1];
        strcpy(Res[1],Res[0]);
        return Res[1];*/
}


void XMFonction::CalculF(SNoeud *PSNoeu)
{/*
        if (PSNoeu->Filsd)
        {
                PSNoeu= PSNoeu->Filsd;
                CalculF(PSNoeu);
                PSNoeu= PSNoeu->Pere;
        }
        if (PSNoeu->Filsg)
        {
                PSNoeu= PSNoeu->Filsg;
                CalculF(PSNoeu);
                PSNoeu= PSNoeu->Pere;
        }
        EffectuerF(PSNoeu,Variables);*/
}


void Convert(SNoeud *Ptrc, TYPE &Valg, TYPE &Vald)
{
        SNoeud *Ptrco;
        if (Ptrc->PListFils)
        {
                Ptrc->PListFils->MoveFirst(Ptrco);
                Valg=((Element *)Ptrco->Info)->Val;
        	
        	Ptrc->PListFils->MoveNext(Ptrco);
        	Vald=((Element *)Ptrco->Info)->Val;
       }
}



int Effectuer(SNoeud *Ptrc, CList<XMObjectX *> *lvar=NULL)
{
        TYPE Valg,Vald; int c;
    	XMVariable *V;
    	XMObjectX *pmobj;
    	Element *PE=(Element *)Ptrc->Info;
    	if (!strcmp(PE->Nom,"+"))
    	{
    		Convert(Ptrc,Valg,Vald);
     		PE->Val=Valg + Vald;
     		return 1;
     	}
     	if (!strcmp(PE->Nom ,"-"))
     	{
     		Convert(Ptrc,Valg,Vald);
      		PE->Val=Valg - Vald;
      		return 1;
     	}
        if (!strcmp(PE->Nom ,"*"))
        {
        	Convert(Ptrc,Valg,Vald);
        	PE->Val=Valg*Vald;
        	return 1;
        }
     	if (!strcmp(PE->Nom ,"/"))
     	{
		Convert(Ptrc,Valg,Vald);
		if (Vald)
		{
		      PE->Val=Valg/Vald;
		      return 1;
		} return 0;
	}
	if (!strcmp(PE->Nom ,"^"))
	{
	       Convert(Ptrc,Valg,Vald);
	       PE->Val=pow(Valg,Vald);
	       return 1;
	}
	if (!strcmp(PE->Nom ,"sin"))
	{
	      Convert(Ptrc,Valg,Vald);
	      PE->Val=sin(Vald);
	      return 1;
	}
  	if (!strcmp(PE->Nom ,"cos"))
    	{
	      Convert(Ptrc,Valg,Vald);
	      PE->Val=cos(Vald);
	      return 1;
	}
	if (!strcmp(PE->Nom ,"tan"))
	{
	      Convert(Ptrc,Valg,Vald);
	      if (!cos(Vald))
	      {
	              PE->Val=tan(Vald);
	              return 1;
	      } return 0;
	}
	if (!strcmp(PE->Nom ,"ln"))
	{
	      Convert(Ptrc,Valg,Vald);
	      if (Vald>0)
              {
              	       PE->Val=log(Vald);
              	       return 1;
              } return 0;
        }
        if (!strcmp(PE->Nom,"abs"))
        {
               Convert(Ptrc,Valg,Vald);
               PE->Val=abs((int )Vald);
               return 1;
        }
        if (!strcmp(PE->Nom,"exp"))
        {
               Convert(Ptrc,Valg,Vald);
               PE->Val=exp(Vald);
               return 1;
        }
        if (!strcmp(PE->Nom,"ch"))
        {
               Convert(Ptrc,Valg,Vald);
               PE->Val=ch(Vald);
               return 1;
        }
        if (!strcmp(PE->Nom,"sh"))
        {
               Convert(Ptrc,Valg,Vald);
               PE->Val=sh(Vald);
               return 1;
        }
        if (!strcmp(PE->Nom,"th"))
        {
               Convert(Ptrc,Valg,Vald);
               PE->Val=th(Vald);
               return 1;
        }
        if (!strcmp(PE->Nom,"sqrt"))
        {
               Convert(Ptrc,Valg,Vald);
               if (Vald>=0)
               {
                      PE->Val=sqrt(Vald);
                      return 1;
               }; return 0;
        }
        if (!strcmp(PE->Nom,"arctan"))
        {
                Convert(Ptrc,Valg,Vald);
               PE->Val=atan(Vald);
                return 1;
        }
        if (!strcmp(PE->Nom,"argch"))
        {
               Convert(Ptrc,Valg,Vald);
               PE->Val=argch(Vald);
               return 1;
        }
        if (!strcmp(PE->Nom,"argsh"))
        {
               Convert(Ptrc,Valg,Vald);
               PE->Val=argsh(Vald);
               return 1;
        }
        if (!strcmp(PE->Nom,"argth"))
        {
               Convert(Ptrc,Valg,Vald);
               PE->Val=argth(Vald);
               return 1;
        }
        if (!strcmp(PE->Nom,"pi"))
        {
               PE->Val=pi;
               return 1;
        }
        /*if (V = GetVariable(Listx,PE->Nom))
        {
               int vld;
               PE->Val = (V->Eval(vld));
               return 1;
        }*/
        if (pmobj = GetXMObjectX(PE->Nom,lvar))
        {
               //Update(F[0]->GetPLV(), LFonc);
               PE->Val = pmobj->Eval(c);
               return c;
        }
        val(PE->Nom,PE->Val,c); if (!c) return 1;
        return 0;
}

XMFonction::~XMFonction()
{
        int i;
        if (Variables)
        {
              for (i=0;Variables[i];i++)
              {
                   delete Variables[i];
                   Variables[i]=NULL;
              }
              delete Variables;
              Variables=NULL;
        }
}



/**********************    Calcul  de  driv    ***************************/


void Convert_Diff(SNoeud *Ptrc, char **Valgs, char **Valds)
{/*
        SNoeud *Ptrco; Element *PE;
        Ptrco=Ptrc->Filsg;
        if (Ptrco)
        {
                PE=(Element *)Ptrco->Info;
                Valgs[0]=PE->Vals;
                Valgs[1]=PE->Vald;
        }
        Ptrco=Ptrc->Filsd;
        if (Ptrco)
        {
                PE=(Element *)Ptrco->Info;
                Valds[0]=PE->Vals;
                Valds[1]=PE->Vald;
        }*/
}

void ConvertF(SNoeud *Ptrc, char **Valgs, char **Valds)
{/*
        SNoeud *Ptrco; Element *PE;
        Ptrco=Ptrc->Filsg;
        if (Ptrco)
        {
                PE=(Element *)Ptrco->Info;
                Valgs[0]=PE->Vals;
        }
        Ptrco=Ptrc->Filsd;
        if (Ptrco)
        {
                PE=(Element *)Ptrco->Info;
                Valds[0]=PE->Vals;
        }*/
}


void EffectuerF(SNoeud *Ptrc, XMVariable **Listx)
{
        int i;
        char *Valgs[2],*Valds[2];
    	XMFonction *F[1];
    	XMVariable *V;
    	Element *PE=(Element *)Ptrc->Info;
    	
    	if (PE->Vals) delete PE->Vals;
    	if (!strcmp(PE->Nom,"+"))
    	{
    	   	ConvertF(Ptrc,Valgs,Valds);
    		PE->Vals=Simplifie_Somme(Valgs[0],Valds[0]);
    		XMTRACE("Valeur gauche %s, droite %s, Somme %s",Valgs[0],Valds[0],PE->Vals);
     		getchar();
     		free(Valgs[0]); Valgs[0]=NULL;
     		free(Valds[0]); Valds[0]=NULL;
     		return ;
     	}
    	if (!strcmp(PE->Nom ,"-"))
     	{
     	        ConvertF(Ptrc,Valgs,Valds);
     	  	PE->Vals=Simplifie_Soust(Valgs[0],Valds[0]);
    		XMTRACE("Valeur gauche %s, droite %s, Somme %s",Valgs[0],Valds[0],PE->Vals);
     		getchar();
     		free(Valgs[0]); Valgs[0]=NULL;
     		free(Valds[0]); Valds[0]=NULL;
     		return ;
     		
     	}
     	if (!strcmp(PE->Nom ,"*"))
        {
        	ConvertF(Ptrc,Valgs,Valds);
        	PE->Vals=Simplifie_Multi(Valgs[0],Valds[0]);
        	free(Valgs[0]); Valgs[0]=NULL;
     		free(Valds[0]); Valds[0]=NULL;
        	return ;
        }
     	if (!strcmp(PE->Nom ,"/"))
     	{
		ConvertF(Ptrc,Valgs,Valds);
		PE->Vals=Simplifie_Quot(Valgs[0],Valds[0]);
		free(Valgs[0]); Valgs[0]=NULL;
     		free(Valds[0]); Valds[0]=NULL;
		return;
	}
	if (!strcmp(PE->Nom ,"^"))
	{
	       ConvertF(Ptrc,Valgs,Valds);
	       PE->Vals=Simplifie_Power(Valgs[0],Valds[0]);
	       free(Valgs[0]); Valgs[0]=NULL;
	       free(Valds[0]); Valds[0]=NULL;
	       return ;
	 }
	 if (!strcmp(PE->Nom ,"sin"))
	 {
	       ConvertF(Ptrc,Valgs,Valds);
	       Simplifie_Sin(Valds[0]);
	       free(Valds[0]); Valds[0]=NULL;
	       return;
	 }
     	 if (!strcmp(PE->Nom ,"cos"))
     	 {
	       ConvertF(Ptrc,Valgs,Valds);
	       PE->Vals=Simplifie_Cos(Valds[0]);
	       free(Valds[0]); Valds[0]=NULL;
	       return;
	 }
	 if (!strcmp(PE->Nom ,"tan"))
	 {
	       ConvertF(Ptrc,Valgs,Valds);
	       PE->Vals=Simplifie_Tan(Valds[0]);
	       free(Valds[0]); Valds[0]=NULL;
	       return ;
	 }
	 if (!strcmp(PE->Nom ,"ln"))
	 {
	       ConvertF(Ptrc,Valgs,Valds);
	       PE->Vals=Simplifie_Ln(Valds[0]);
	       XMTRACE("\nOn a peut %s",PE->Vald);
	       getchar();
	       free(Valds[0]); Valds[0]=NULL;
	       return ;
         }
         if (!strcmp(PE->Nom,"abs"))
         {
                ConvertF(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Abs(Valds[0]);
                free(Valds[0]); Valds[0]=NULL;
                return ;
         }
         if (!strcmp(PE->Nom,"exp"))
         {
                ConvertF(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Exp(Valds[0]);
                free(Valds[0]); Valds[0]=NULL;
                return ;
         }
         if (!strcmp(PE->Nom,"ch"))
         {
                ConvertF(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Ch(Valds[0]);
                free(Valds[0]); Valds[0]=NULL;
                return ;
         }
         if (!strcmp(PE->Nom,"sh"))
         {
                ConvertF(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Sh(Valds[0]);
                free(Valgs[0]); Valgs[0]=NULL;
               free(Valds[0]); Valds[0]=NULL;
                return ;
         }
         if (!strcmp(PE->Nom,"th"))
         {
                ConvertF(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Th(Valds[0]);
                free(Valds[0]); Valds[0]=NULL;
                return ;
         }
         if (!strcmp(PE->Nom,"sqrt"))
         {
                ConvertF(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Sqrt(Valds[0]);
                free(Valds[0]); Valds[0]=NULL;
                return;
         }
         if (!strcmp(PE->Nom,"arctan"))
         {
                ConvertF(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Arctan(Valds[0]);
                free(Valds[0]); Valds[0]=NULL;
                return;
         }
         /*
         if (!strcmp(PE->Nom,"argch"))
         {
                ConvertF(Ptrc,Valgs,Valds);
                PE->Val=argch(Vald);
                free(Valds[0]); Valds[0]=NULL;
                return 1;
         }
         if (!strcmp(PE->Nom,"argsh"))
         {
                ConvertF(Ptrc,Valg,Vald,Listx,LVari,LFonc);
                PE->Val=argsh(Vald);
                free(Valds[0]); Valds[0]=NULL;
                return 1;
         }
         if (!strcmp(PE->Nom,"argth"))
         {
                ConvertF(Ptrc,Valg,Vald,Listx,LVari,LFonc);
                PE->Val=argth(Vald);
                free(Valds[0]); Valds[0]=NULL;
                return ;
         }*/
         if (V = GetVariable(Listx,PE->Nom))
         {
                int vld;
                PE->Vals = Copie(0, strlen(V->EvalF(vld)), V->EvalF(vld));
                return ;
         }

     /*  if (ExisteVar(LFonc,PE->Nom,V))
         {
                PE->Vals=new char[strlen(V.Xs)+1];
                strcpy(PE->Vals,V.Xs);
                return ;
         }
     */
         //if (ExisteFon(LFonc,PE->Nom,F))
         //{
         //       PE->Vals=F[0]->EvalF();
         //       return ;
         //}
         PE->Vals = Copie(0, strlen(PE->Nom), PE->Nom);
         return ;
}


void Derivee(SNoeud *Ptrc,char *VarDe)
{
        TYPE Vld,Vlg; int i,nd,ng;
        char *Valgs[2],*Valds[2],*Res1,*Res2;
    	XMFonction *F[1];
    	Element *PE=(Element *)Ptrc->Info;
    	
    	XMTRACE("\n Nom: %s et %s",PE->Nom,PE->Vald);
    	getchar();
    	if (PE->Vald) delete PE->Vald;
    	if (!strcmp(PE->Nom,"+"))
    	{
    	   	Convert_Diff(Ptrc,Valgs,Valds);
    		PE->Vals=Simplifie_Somme(Valgs[0],Valds[0]);
    		PE->Vald=Simplifie_Somme(Valgs[1],Valds[1]);
    	 	XMTRACE("Valeur gauche %s, droite %s, Somme %s et %s",Valgs[1],Valds[1],PE->Vald,PE->Vals);
     		getchar();
     		return ;
     	}
    	if (!strcmp(PE->Nom ,"-"))
     	{
     	  	Convert_Diff(Ptrc,Valgs,Valds);
     	  	PE->Vals=Simplifie_Soust(Valgs[0],Valds[0]);
    		PE->Vald=Simplifie_Soust(Valgs[1],Valds[1]);
    		XMTRACE("Valeur gauche %s, droite %s, Somme %s et %s",Valgs[1],Valds[1],PE->Vald,PE->Vals);
     		getchar();
     		return ;
     		
     	}
     	if (!strcmp(PE->Nom ,"*"))
        {
        	Convert_Diff(Ptrc,Valgs,Valds);
        	PE->Vals=Simplifie_Multi(Valgs[0],Valds[0]);
        	Res1=Simplifie_Multi(Valgs[1],Valds[0]);
        	Res2=Simplifie_Multi(Valgs[0],Valds[1]);
        	PE->Vald=Simplifie_Somme(Res1,Res2);
        	delete Res1; delete Res2;
        	return ;
        }
     	if (!strcmp(PE->Nom ,"/"))
     	{
		Convert_Diff(Ptrc,Valgs,Valds);
		PE->Vals=Simplifie_Quot(Valgs[0],Valds[0]);
		PE->Vald=Simplifie_Multi(Valgs[1],Valds[0]);
		Res2=Simplifie_Multi(Valgs[0],Valds[1]);
		Res1=Simplifie_Soust(PE->Vald,Res2);
		delete PE->Vald; delete Res2;
		Res2=Simplifie_Power(Valds[0],"2");
		PE->Vald=Simplifie_Quot(Res1,Res2);
		delete Res1, delete Res2;
		return;
	}
	if (!strcmp(PE->Nom ,"^"))
	{
	       Convert_Diff(Ptrc,Valgs,Valds);
	       PE->Vals=Simplifie_Power(Valgs[0],Valds[0]);
	       XMTRACE("\n Yes %s",PE->Vals);
	       getchar();
	       Res1=Simplifie_Multi(Valds[0],Valgs[1]);
	       XMTRACE("\n Yes %s et %s",Res1,Valds[0]);
               getchar();
               PE->Vald=Simplifie_Soust(Valds[0],"1");
               XMTRACE("\n Yes %s",PE->Vald);
               getchar();

	       Res2=Simplifie_Power(Valgs[0],PE->Vald);
	       XMTRACE("\n Yes %s",Res2);
               getchar();

	       //delete PE->Vald;
	       PE->Vald=Simplifie_Multi(Res1,Res2);
	       XMTRACE("\n Yes %s",PE->Vald);
               getchar();

	       delete Res1; delete Res2;
	       return ;
	 }
	 if (!strcmp(PE->Nom ,"sin"))
	 {
	       Convert_Diff(Ptrc,Valgs,Valds);
	       PE->Vals=Simplifie_Sin(Valds[0]);
	       Res1=Simplifie_Cos(Valds[0]);
	       PE->Vald=Simplifie_Multi(Valds[1],Res1);
	       delete Res1;
	       return;
	 }
     	 if (!strcmp(PE->Nom ,"cos"))
     	 {
	       Convert_Diff(Ptrc,Valgs,Valds);
	       PE->Vals=Simplifie_Cos(Valds[0]);
	       Res1=Simplifie_Sin(Valds[0]);
	       XMTRACE("\nC'est %s",Res1);
	       getchar();
	       if (Res1[0]=='-') Res1=strchr(Res1,'-'); else
	       {
	               XMTRACE("\n Los %s",Res1);
	               getchar();
	               Res2=Res1;
	               Res1=new char[strlen(Res2)+2];
	               strcpy(Res1,"-");
	               strcat(Res1,Res2);
	               delete Res2;
	       }
	       PE->Vald=Simplifie_Multi(Valds[1],Res1);
	       delete Res1;
	       return;
	 }
	 if (!strcmp(PE->Nom ,"tan"))
	 {
	       Convert_Diff(Ptrc,Valgs,Valds);
	       PE->Vals=Simplifie_Tan(Valds[0]);
	       Res1=Simplifie_Somme("1",PE->Vals);
	       PE->Vald=Simplifie_Multi(Valds[1],Res1);
	       delete Res1;
	       return ;
	 }
	 if (!strcmp(PE->Nom ,"ln"))
	 {
	       Convert_Diff(Ptrc,Valgs,Valds);
	       PE->Vals=Simplifie_Ln(Valds[0]);
	       PE->Vald=Simplifie_Quot(Valds[1],Valds[0]);
	       XMTRACE("\nOn a peut %s",PE->Vald);
	       getchar();
	
	       return ;
         }
         if (!strcmp(PE->Nom,"abs"))
         {
                Convert_Diff(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Abs(Valds[0]);
                Res1=new char[strlen("Sgn()")+strlen(Valds[0])+1];
                strcpy(Res1,"Sgn(");
                strcat(Res1,Valds[0]);
                strcpy(Res1,")");
                PE->Vald=Simplifie_Multi(Res1,Valds[1]);
                delete Res1;
                return ;
         }
         if (!strcmp(PE->Nom,"exp"))
         {
                Convert_Diff(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Exp(Valds[0]);
                PE->Vald=Simplifie_Multi(Valds[1],PE->Vals);
                return ;
         }
         if (!strcmp(PE->Nom,"ch"))
         {
                Convert_Diff(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Ch(Valds[0]);
                Res1=Simplifie_Sh(Valds[0]);
                PE->Vald=Simplifie_Multi(Valds[1],Res1);
                delete Res1;
                return ;
         }
         if (!strcmp(PE->Nom,"sh"))
         {
                Convert_Diff(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Sh(Valds[0]);
                Res1=Simplifie_Ch(Valds[0]);
                PE->Vald=Simplifie_Multi(Valds[1],Res1);
                delete Res1;
                return ;
         }
         if (!strcmp(PE->Nom,"th"))
         {
                Convert_Diff(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Th(Valds[0]);
                Res1=Simplifie_Power(PE->Vals,"2");
                Res2=Simplifie_Soust("1",Res1);
                PE->Vald=Simplifie_Multi(Valds[1],Res2);
                delete Res1; delete Res2;
                return ;
         }
         if (!strcmp(PE->Nom,"sqrt"))
         {
                Convert_Diff(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Sqrt(Valds[0]);
                Res1=Simplifie_Power(PE->Vals,"-1/2");
                Res2=Simplifie_Multi(Valds[1],Res1);
                PE->Vald=Simplifie_Multi("1/2",Res2);
                delete Res1; delete Res2;
                return;
         }
         if (!strcmp(PE->Nom,"arctan"))
         {
                Convert_Diff(Ptrc,Valgs,Valds);
                PE->Vals=Simplifie_Arctan(Valds[0]);
                Res1=Simplifie_Power(Valds[0],"2");
                Res2=Simplifie_Somme("1",Res1);
                PE->Vald=Simplifie_Multi(Valds[1],Res2);
                delete Res1; delete Res2;
                return;
         }
         /*
         if (!strcmp(PE->Nom,"argch"))
         {
                Convert_Diff(Ptrc,Valgs,Valds);
                PE->Val=argch(Vald);
                return 1;
         }
         if (!strcmp(PE->Nom,"argsh"))
         {
                Convert_Diff(Ptrc,Valg,Vald,Listx,LVari,LFonc);
                PE->Val=argsh(Vald);
                return 1;
         }
         if (!strcmp(PE->Nom,"argth"))
         {
                Convert_Diff(Ptrc,Valg,Vald,Listx,LVari,LFonc);
                PE->Val=argth(Vald);
                return ;
         }*/
         if (!strcmp(VarDe,PE->Nom))
         {
                PE->Vald=new char[2];
                PE->Vald[0]='1'; PE->Vald[1]='\0';
                PE->Vals=new char[strlen(PE->Nom)+1];
                strcpy(PE->Vals,PE->Nom);
                XMTRACE("\n La variable existe et vaut: %s La derivee: %s",PE->Nom,PE->Vald);
                getchar();
                return ;
         }
     /*    if (ExisteFon(LFonc,PE->Nom,F))
          {
                 char *Res=F[0]->Diff(VarDe);
                 PE->Vald=new char[strlen(Res)+1];
                 strcpy(PE->Vald,Res);
                 return ;
         }
     */
         PE->Vals=new char[strlen(PE->Nom)+1];
         strcpy(PE->Vals,PE->Nom);
         PE->Vald=new char[2];
         strcpy(PE->Vald,"0");
         XMTRACE("\n Fini: %s",PE->Vald);
         getchar();
         //val(PE->Vals,Vald,c); if (!c) return 1;
         return ;
}




/*************      XMFonction ANNEXE    ******************/




int Test(char c, char *Tab, int &i)
{
        for (i=0;(Tab[i]!='\0');i++)
        {
                if (Tab[i]==c) return 1;
        }
        return 0;
}

void val(char *s, TYPE & valeur, int &c)
{
        char TabA[14]={'0','1','2','3','4','5','6','7','8','9','.','e','E','\0'};
        int Tab[2]={0,0};
        int i,j;

        for (i=1;s[i]!='\0';i++)
        {
                if (Test(s[i],TabA,j))
                {
                        if (s[i]=='.')
                        {
                                if (Tab[1]) i=0; else Tab[1]++;
                        } else
                        if ((s[i]=='e') || (s[i]=='E'))
                        {
                                if (Tab[2]) i=0; else Tab[2]++;
                        }
                 } else i=0;
                 if (!i) { c =1; return;}
        }
        valeur=atof(s);
        c=0;
}


XMVariable *GetVariable(XMVariable **Listx, char *NomVar)
{
        if (!Listx) return 0;
        XMVariable *var;
        int i;
        for (i=0;Listx[i];i++)
        {
                var = Listx[i];
                if (!strcmp(var->GetName(),NomVar)) return var;
        }
        return 0;
}
/*
void Update(Variable ** Listx, CList <SObjectX *>*PLV)
{
        Variable *V;
        if (Listx)
        {
                int i;
                SObjectX *Obj;
                for (i=0;Listx[i];i++)
                {
                        PLV->MoveFirst(Obj);
                        while (!PLV->Eol())
                        {
                                if (Obj->Type() == TO_VARAIABLE)
                                {
                                        V=(Variable *)Obj->ObjX;
                                        if (!strcmp(Listx[i]->Nom,V->Nom))
                                	{
                                        	Listx[i]->X=V->X;
                                        	break;
                                	}
                               	}
                               	PLV->MoveNext(Obj);
                        }
                }
        }
}*/

int EstStandard(char *Nom)
{
        if (!strcmp(Nom,"cos"))	return 1;
        if (!strcmp(Nom,"sin"))	return 1;
        if (!strcmp(Nom,"tan")) return 1;
        if (!strcmp(Nom,"abs")) return 1;
        if (!strcmp(Nom,"exp")) return 1;
        if (!strcmp(Nom,"ln"))  return 1;
        if (!strcmp(Nom,"ch"))  return 1;
        if (!strcmp(Nom,"sh"))	return 1;
        if (!strcmp(Nom,"th"))  	return 1;
        if (!strcmp(Nom,"det"))  	return 1;
        if (!strcmp(Nom,"sqrt"))	return 1;
        if (!strcmp(Nom,"argch"))	return 1;
        if (!strcmp(Nom,"argth"))	return 1;
        if (!strcmp(Nom,"argsh"))	return 1;
        if (!strcmp(Nom,"arctan"))	return 1;
        return 0;
}


/*****    FIN DES XMFonctionS ANNEXES      ***/


