 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: maths.h,v 1.2 2000/11/02 22:10:08 daville Exp $
 * $Log: maths.h,v $
 * Revision 1.2  2000/11/02 22:10:08  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef MATHS
#define MATHS
#include "Liste.h"
#include "math.h"


int Eval(char *Exp, char *Result);
int Evaf(char *Exp, char *Result);
int Derivee(char *Exp, char *Result);
int Integrale(char *Exp, char *Result);
int Limit(char *Exp, char *Result);
int Module(char *Exp, char *Result);
int Somme(char *Exp, char *Result);
int DecompFonction(char *Expression, char **NomFonc,  char **Variabl, char **MessadeErr);
int DecompIntervalle(char *Intervalle, char **VarI, TYPE &x1, TYPE &x2, char **MessageErr);
char *GetIntervalle(char *Exp, char c);
char *GetIntervalles(char *inter);
XMFonction *DoFonction(char *Nom, char *Exp, char *Intervalles, int &EX);
XMFonction *DoFonction(char *Exp, char **Message);
int TestFonction(char *Exp,char **Nom);
int CompteLig(char *Exp);
char *GetCoord(char *Exp);
int EstVariable(char *Exp);
#endif