 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: matrice.h,v 1.2 2000/11/02 22:10:08 daville Exp $
 * $Log: matrice.h,v $
 * Revision 1.2  2000/11/02 22:10:08  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef MATRICE
#define MATRICE
#include "vecteur.h"

class XMMatrice: public XMObjectX
{
        XMVecteur **mMat;
        int NbreLig,NbreCol;
        public:
        XMMatrice();
        XMMatrice(XMMatrice &M);
        XMMatrice(int NL, int NC);
        void Set(int i, int j, /*Fonction*/XMObjectX *F);
        void Set(int j, XMVecteur *vect);
        char *DetF();
        float Det();
        XMMatrice *Inv();
        XMMatrice *Com();
        XMMatrice *Trans();
        XMMatrice *Compl();
        XMMatrice *Mineure(int i, int j);

        char *Formatted();
        TYPE  Eval(int &i, CList <XMObjectX *> *lvar=NULL){};
       	char *EvalF(int &i, CList <XMObjectX *> *lvar=NULL){return DetF();};
       	char *Affiche(){};
       	void  Lecture();
       	XMObjectX *XEval(int &i, CList <XMObjectX *> *lvar=NULL){return (XMObjectX *)0;}
       	XMObjectX *Diff(char *var){};
       	XMObjectX *Clone(){};

        ~XMMatrice();
};
#endif