 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: mobjectx.h,v 1.2 2000/11/02 22:10:08 daville Exp $
 * $Log: mobjectx.h,v $
 * Revision 1.2  2000/11/02 22:10:08  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef XMObjectX_H
#define XMObjectX_H
#include <stdio.h>
#include "type.h"
#include "chaine.h"
#include "Liste.h"

//////////////////////////////////////////////////////////////////////
XMObjectX *GetObjectX(char *name);////////////////////////////////////
XMObjectX *GetXMObjectX(char *name, CList<XMObjectX *> *list=NULL);///
//////////////////////////////////////////////////////////////////////

class XMObjectX
{
	private : void *mObjectX;
        protected:
        	//[0] <==> Expression interne
        	//[1] <==> Expression externe
        	char *mExpression[2], *mName;
        	CList <XMObjectX *> *mLVar;
        	TObjectX mType;
        public:
        	XMObjectX();
        	XMObjectX(XMObjectX &obj);
        	XMObjectX(XMObjectX *obj);
        	XMObjectX(char *expi, char *expe=NULL, char *nom=NULL);
        	//XMObjectX(char *expi, char *expe=NULL, char *nom=NULL, CList <XMObjectX *> *lvar);
        	void Set(char *expi, char *expe=NULL, char *nom=NULL);
        	void SetName(char *Name);
        	void SetExp(int k, char *exp); //k=0 <-> interne, k=1<-> externe
        	char *GetName();
        	char *GetExp(int k);

      	        int NVariables();        	
      	        void *Variables();
      	        void AddVariable(XMObjectX *obj);
      	        void AddVariables(CList <XMObjectX *> *lvar);
        	XMObjectX *Variable(int k);
        	XMObjectX *Variable(char *name);
        	
        	TObjectX &Type(){return mType;}
        	
        	void *&ObjectX(){return mObjectX;}// Assure la compatibilte avec SObjectX
        	
        	virtual char *Formatted()=0;
        	virtual TYPE  Eval(int &i, CList <XMObjectX *> *lvar=NULL)=0;
        	virtual char *EvalF(int &i, CList <XMObjectX *> *lvar=NULL)=0;
        	virtual XMObjectX *XEval(int &i, CList <XMObjectX *> *lvar=NULL)=0;
        	virtual XMObjectX *Diff(char *x)=0;
        	virtual XMObjectX *Clone()=0;
     	        virtual char *Affiche()=0;
        	virtual void  Lecture()=0;
		virtual ~XMObjectX();
};

#endif  /* XMObjectX_H */