 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: motor.h,v 1.2 2000/11/02 22:10:08 daville Exp $
 * $Log: motor.h,v $
 * Revision 1.2  2000/11/02 22:10:08  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef MOTOR_H
#define MOTOR_H

#include "type.h"
#include "screen.h"
#include "syscoord.h"

class Motor
{
protected:
	Screen *mScreen;
	SysCoord *mSysCoord;
public:
	Motor();
	Motor(Screen *screen);
	void SetScreen(int *pt, int largeur, int hauteur);
	int GetDim();
	virtual void Configure()= 0;
	virtual void EvalXY(int &vld, TYPE *pt, TYPE *Res)=0;
	virtual int EvalX(int &vld, TYPE *pt)=0;
	virtual int EvalY(int &vld, TYPE *pt)=0;
};

#endif	/* MOTOR_H */