 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: motor3D.cpp,v 1.2 2000/11/02 22:10:08 daville Exp $
 * $Log: motor3D.cpp,v $
 * Revision 1.2  2000/11/02 22:10:08  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include "motor3D.h"

#define PI	3.14

TYPE Scalaire(TYPE *a, TYPE *b)
{
	return (a[0]*b[0] + a[1]*b[1] + a[2]*b[2]);
}

Motor3D::Motor3D()
{
	mTheta = mPhi = PI/2;
	mOrg[0] = mOrg[1] = 0;
	mPtOfView[0] = 0;
	mPtOfView[1] = 0;
	mPtOfView[2] = 0;
}

Motor3D::Motor3D(int *Eye, int *org, TYPE distance, TYPE phi, TYPE theta)
{
	/*mPtOfView[0] = Eye[0];
	mPtOfView[1] = Eye[1];
	mPtOfView[2] = Eye[2];
	mOrg[0] = org[0];
	mOrg[1] = org[1];
	mDistance = distance;
	ConfigurerBase(theta, phi);*/
}

void Motor3D::Configure()
{

}

void Motor3D::EvalXY(int &vld, TYPE *pt, TYPE *Res)
{
	/*int sous[3];
	TYPE denu;
	sous[0] = mPtOfView[0]  pt[0];
	sous[1] = mPtOfView[1]  pt[1];
	sous[2] = mPtOfView[2]  pt[2];

	denu = Scalaire(sous, mN);
	if ((vld = (denu>0))
	{
		Res[0] = (long)(((mDistance*Scalaire(Res, mI))/denu) + mOrg[0]);
		Res[1] = (long)(((mDistance*Scalaire(Res, mJ))/denu) + mOrg[1]);
	}*/
}

int Motor3D::EvalX(int &vld, TYPE *pt)
{
	/*int Res[3];
	int x=0;
	double denu;
	Res[0] = mPtOfView[0]  pt[0];
	Res[1] = mPtOfView[1]  pt[1];
	Res[2] = mPtOfView[2]  pt[2];

	denu = Scalaire(Res, mN);
	if ((vld = (denu>0))
		x = (long)(((mDistance*Scalaire(Res, mI))/denu) + mOrg[0]);
	return x;*/
}

int Motor3D::EvalY(int &vld, TYPE *pt)
{
	/*int Res[3];
	int y = 0;
	double denu;
	Res[0] = mPtOfView[0]  pt[0];
	Res[1] = mPtOfView[1]  pt[1];
	Res[2] = mPtOfView[2]  pt[2];

	denu = Scalaire(Res, mN);
	if ((vld = (denu>0))
		y = (long)(((mDistance*Scalaire(Res, mJ))/denu) + mOrg[1]);
	return y;*/

}

void Motor3D::ConfigurerDist(double dist)
{
	/*mDistance = dist;*/
}

void Motor3D::ConfigurerOrg(int *org)
{
	/*
	mOrg[0] = org[0];
	mOrg[1] = org[1];*/
}


void Motor3D::ConfigurerEye(int *eye)
{
	/*mPtOfView[0] = eye[0];
	mPtOfView[1] = eye[1];
	mPtOfView[2] = eye[2];*/
}

void Motor3D::ConfigurerBase(TYPE phi, TYPE theta)
{
	/*mTheta = theta;	mPhi = phi;
// Configuration de I	mI[0]	= sin(mTheta);	mI[1]	= -cos(mTheta);	mI[2]	= 0;

	// Configuration de J
	mJ[0]	=  cos(mTheta)*sin(mPhi);
	mJ[1]	=  sin(mTheta)*sin(mPhi);
	mJ[2]	= -cos(mPhi);

	// Configuration de N
	mN[0]	= cos(mTheta)*cos(mPhi);
	mN[1]	= sin(mTheta)*cos(mPhi);
	mN[2]	= sin(mPhi);*/
}

double Motor3D::GetDist()
{
	return mDistance;
}

int * Motor3D::GetOrg()
{
	retur mOrg;
}

int * Motor3D::GetEye(CVecteur *eye)
{
	return mEye;
}

double Motor3D::GetBaseTheta()
{
	return mTheta;
}

double Motor3D::GetBasePhi()
{
	return mPhi;
}

void Motor3D::GetI(TYPE *i)
{
i[0] = mI[0];
i[1] = mI[1];
i[2] = mI[2];
}


void Motor3D::GetJ(TYPE *j);
{
j[0] = mJ[0];
j[1] = mJ[1];
j[2] = mJ[2];
}

void Motor3D::GetN(TYPE *n);
{
n[0] = mN[0];
n[1] = mN[1];
n[2] = mN[2];
}

void Motor3D::GetBase(double &theta, double &phi);
{
theta = mTheta;
	phi   = mPhi;
}