 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: number.cpp,v 1.2 2000/11/02 22:09:52 daville Exp $
 * $Log: number.cpp,v $
 * Revision 1.2  2000/11/02 22:09:52  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "number.h"
 
TYPE Pgdc(TYPE x,TYPE y)
{
        if (!y) return x; else return Pgdc(y, fmod(x,y));
}

char *Simplifie_Somme(char *Valgs, char *Valds)
{
        char *endg,*endd;
        char *Res,*Tmp,Ch[50];
        TYPE Valg,Vald;
        
        Valg=strtod(Valgs,&endg);
        Vald=strtod(Valds,&endd);
        if ((!*endg) && (!*endd))
        {
                gcvt(Valg+Vald,SGNF,Ch);
                Res=new char[strlen(Ch)+1];
                strcpy(Res,Ch);
                return Res;
        }
        if (((Valg==0) && (!*endg)) || ((Vald==0) && (!*endd)))
        {
                if ((Valg==0) && (!*endg)) Tmp=Valds;
                if ((Vald==0) && (!*endd)) Tmp=Valgs;
                Res=new char[strlen(Tmp)+1];
                strcpy(Res,Tmp);
                return Res;
        }
        Res=new char[strlen(Valgs)+1+strlen(Valds)+1];
        strcpy(Res,Valgs);
        if (Valds[0]!='-') strcat(Res,"+");
        strcat(Res,Valds);
        return Res;
}
               
char *Simplifie_Soust(char *Valgs, char *Valds)
{
        char *endg,*endd;
        char *Res,*Tmp,Ch[50];
        TYPE Valg,Vald;
        
        Valg=strtod(Valgs,&endg);
        Vald=strtod(Valds,&endd);
        if ((!*endg) && (!*endd))
        {
                gcvt(Valg-Vald,SGNF,Ch);
                Res=new char[strlen(Ch)+1];
                strcpy(Res,Ch);
                return Res;
        }
        if (((Valg==0) && (!*endg)) || ((Vald==0) && (!*endd)))
        {
                if ((Valg==0) && (!*endg))
                {
                        Res=new char[strlen(Valds)+1];
                        if (Valds[0]!='-') strcpy(Res,"-");
                        strcat(Res,Valds);
                        return Res;
                }
                if ((Vald==0) && (!*endd)) Tmp=Valgs; else Tmp=Valds;
                Res=new char[strlen(Tmp)+1];
                strcpy(Res,Tmp);
                return Res;
        }
        Res=new char[strlen(Valgs)+1+strlen(Valds)+1];
        strcpy(Res,Valgs);
        if (Valds[0]!='-')
        {
                strcat(Res,"-");
                Tmp=Valds;
        } else
        {
                strcat(Res,"+");
                Tmp=strchr(Valds,'-');
        }
        strcat(Res,Tmp);
        return Res;
}


char *Simplifie_Multi(char *Valgs, char *Valds)
{
        char *endg,*endd;
        char *Res,*Tmp,*Tmp1,*S=NULL,Ch[50];
        TYPE Valg,Vald;
        
        Valg=strtod(Valgs,&endg);
        Vald=strtod(Valds,&endd);
        if ((!*endg) && (!*endd))
        {
                gcvt(Valg*Vald,SGNF,Ch);
                Res=new char[strlen(Ch)+1];
                strcpy(Res,Ch);
                return Res;
        }
        if (((Valg==1) && (!*endg)) || ((Vald==1) && (!*endd)))
        {
                if ((Valg=1) && (!*endg)) Tmp=Valds;
                if ((Vald=1) && (!*endd)) Tmp=Valgs;
                Res=new char[strlen(Tmp)+1];
                strcpy(Res,Tmp);
		return Res;
        }
        if (((Valg==0) && (!*endg)) || ((Vald==0) && (!*endd)))
        {
                Res=new char[2];
                strcpy(Res,"0");
                return Res;
        }
        Res=new char[1+strlen(Valgs)+1+strlen(Valds)+2];
        Tmp=Valgs; Tmp1=Valds;
        if ((Valgs[0]=='-') || (Valds[0]=='-'))
        {
                if ((Valgs[0]=='-') && (Valds[0]=='-'))
        	{
         	       Tmp++;
         	       Tmp1++;
        	} else
        	{
        	       if (Valgs[0]=='-') Tmp++;
        	       if (Valds[0]=='-') Tmp1++;
        	       S=new char[2]; strcpy(S,"-");
        	       printf("\n VBvt %s",Tmp1);
        	       getchar();
        	}
        }
        if (S)
        {
                strcpy(Res,S);
                if (strcmp(Tmp,"1")) strcat(Res,Tmp);
                delete S;
        } else strcpy(Res,Tmp);
        if (strcmp(Tmp,"1")) strcat(Res,"*");
        strcat(Res,"(");
        strcat(Res,Tmp1);
        strcat(Res,")");
        printf("\n Retour pour le produit %s",Res);
        getchar();
        return Res;
}

char *Simplifie_Power(char *Valgs, char *Valds)
{
        char *endg,*endd;
        TYPE Valg,Vald;
        char *Res;
        
        Valg = strtod(Valgs,&endg);
        Vald = strtod(Valds,&endd);
        if (!((endg[0]) || (endd[0])))
        {
                char chn[15];
                gcvt(pow(Valg,Vald),15,chn);
                Res = new char[strlen(chn)+1];
                strcpy(Res,chn);
                return Res;						// MEGA BUGGGGGGGGGG
        }
        printf(" 8. YES\n");
        if ((Vald==0) && (!*endd))
        {
                Res=new char[2]; strcpy(Res,"0");
                return Res;
        }
        if (strlen(Valds)==1)
        {
                if (Vald==1)
                {
                        Res= new char[strlen(Valgs)+1];
                        strcpy(Res,Valgs);
                        return Res;
                }
                Res=new char[strlen(Valgs)+1+2];
                sprintf(Res,"%s^%s", Valgs,Valds);
                return Res;
        }
        Res= new char[1+strlen(Valgs)+3+strlen(Valds)+2];
        sprintf(Res,"(%s)^(%s)", Valgs,Valds);
        return Res;
}

char *Simplifie_Quot(char *Valgs,char *Valds)
{
        char *endg,*endd;
        char *Res,*Tmp,*Tmp1,*S=NULL;
        TYPE Valg,Vald,pg;
        
        Valg=strtod(Valgs,&endg);
        Vald=strtod(Valds,&endd);
        if (!strcmp(Valgs,Valds))
        {
                Res=new char[2];
                strcpy(Res,"1");
                return Res;
        }
        if ((!*endg) && (!*endd))
        {
                char *ptr[2];
                pg = Pgdc(Valg,Vald);
                gcvt((Valg/pg),SGNF,ptr[0]);
                gcvt((Vald/pg),SGNF,ptr[1]);
                Res=new char[strlen(ptr[0])+1+strlen(ptr[1])+1];
                sprintf(Res,"%f/%f",ptr[0],ptr[1]);
                return Res;
        }
        if ((Valg==0) && (!*endg))
        {
                Res=new char[2];
                strcpy(Res,"0");
                return Res;
        }
        Res=new char[1+strlen(Valgs)+3+strlen(Valds)+2];
        Tmp=Valgs; Tmp1=Valds;
        if ((Valgs[0]=='-') || (Valds[0]=='-'))
        {
                if ((Valgs[0]=='-') && (Valds[0]=='-'))
        	{
         	       Tmp=Valgs+1;
         	       Tmp1=Valds+1;
        	} else
        	{
        	       if (Valgs[0]=='-')
        	       {
        	               Tmp=Valgs+1;
        	               S=new char[2]; strcpy(S,"-");
        	       } else Tmp=Valgs;
        	       if (Valds[0]=='-')
        	       {
        	               Tmp1=Valds+1;
        	               S=new char[2]; strcpy(S,"-");
        	       } else Tmp1=Valds;
        	       printf("\n VBvt %s",Tmp1);
        	       getchar();
        	}
        }
        Valg=strlen(Valgs);
        Vald=strlen(Valds);
        if (S)
        {
                strcpy(Res,S);
                if (Valg>1) strcat(Res,"(");
        } else if (Valg>1) strcpy(Res,"(");
        if (Vald>1) strcat(Res,Tmp); else strcpy(Res,Tmp);
        if (Valg>1) strcat(Res,")");
	strcat(Res,"/");
	if (Vald>1) strcat(Res,"(");
        strcat(Res,Tmp1);
        if (Vald>1) strcat(Res,")");
        return Res;
}

char *Simplifie_Ln(char *Valds)
{
        char *endd;
        char *Res,*Tmp;
        TYPE Vald;
        
        Vald=strtod(Valds,&endd);
        if ((!*endd) && (Vald==1))
        {
                Res=new char[2];
                strcpy(Res,"0");
                return Res;
        }
        Res=new char[5+strlen(Valds)];
        sprintf(Res,"ln(%s)",Valds);
        return Res;
}

char *Simplifie_Abs(char *Valds)
{
}

char *Simplifie_Exp(char *Valds)
{
        char *endd;
        char *Res,*Tmp;
        TYPE Vald;
        
        Vald=strtod(Valds,&endd);
        if ((!*endd) && (!strcmp(Valds,"0")))
        {
                Res=new char[2];
                strcpy(Res,"1");
                return Res;
        }
        Res=new char[5+strlen(Valds)];
        sprintf(Res,"exp(%s)",Valds);
        return Res;
}

char *Simplifie_Cos(char *Valds)
{
        char *endd;
        char *Res,*Tmp,Ch[50];
        TYPE Vald;
        
        Vald=strtod(Valds,&endd);
        if (!*endd)
        {
                Vald=cos(Vald);
                if ((Vald==-1) || (Vald==0) || (Vald==1))
                {
                        gcvt(Vald,SGNF,Ch);
                        Res=new char[strlen(Ch)+1];
                        strcpy(Res,Ch);
                        return Res;
                }
        }
        if (Valds[0]=='-') Tmp=strchr(Valds,'-'); else Tmp=Valds;
        Res=new char[6+strlen(Tmp)];
        sprintf(Res,"cos(%s)",Tmp);
        return Res;
}

char *Simplifie_Sin(char *Valds)
{
        char *endd;
        char *Res,*Tmp,Ch[50];
        TYPE Vald;
        
        Vald=strtod(Valds,&endd);
        if (!*endd)
        {
                Vald=sin(Vald);
                if ((Vald==-1) || (Vald==0) || (Vald==1))
                {
                        gcvt(Vald,SGNF,Ch);
                        Res=new char[strlen(Ch)+1];
                        strcpy(Res,Ch);
                        return Res;
                }
        }
        Res=new char[6+strlen(Valds)];
        strcpy(Res,"sin(");
        if (Valds[0]=='-')
        {
                strcpy(Res,"-");
                strcat(Res,"sin(");
                Tmp=strchr(Valds,'-');
      	} else Tmp=Valds;
        strcat(Res,Tmp);
        strcat(Res,")");
        return Res;
}

char *Simplifie_Tan(char *Valds)
{
        char *endd;
        char *Res,*Tmp;
        TYPE Vald;
        
        Vald=strtod(Valds,&endd);
        if (!*endd)
        {
                Vald=cos(Vald);
                if ((Vald=-1) || (Vald=0) || (Vald=1))
                {
                        gcvt(Vald,SGNF,Tmp);
                        Res=new char[strlen(Tmp)+1];
                        strcpy(Res,Tmp);
                        return Res;
                }
        }
        return Valds;
}

char *Simplifie_Ch(char *Valds)
{
}

char *Simplifie_Sh(char *Valds)
{
}

char *Simplifie_Th(char *Valds)
{
}

char *Simplifie_Arctan(char *Valds)
{
}

char *Simplifie_Arccos(char *Valds)
{
}

char *Simplifie_Arcsin(char *Valds)
{
}

char *Simplifie_Argth(char *Valds)
{
}

char *Simplifie_Sqrt(char *Valds)
{
}