 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: plot.cpp,v 1.2 2000/11/02 22:09:52 daville Exp $
 * $Log: plot.cpp,v $
 * Revision 1.2  2000/11/02 22:09:52  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include "plot.h"

void XMPlot::Add(XMObjectX *ob)
{
	switch (ob->Type())
	{
		case TO_INTERVALLE:
			if (!mSyscoord) mSyscoord = new SysCoord;
			mSyscoord->Add((XMIntervalle *)ob);
			break;
		case TO_SYSCOORD:
			mSyscoord = (SysCoord *)(ob);
			break;
		case TO_PLOTER:
			if (!mAPloter) mAPloter = new CList <XMPloter *>;
			mAPloter->Add((XMPloter *)ob);
			break;
		default:
			{
				XMPloter *plter;
				if (!mAPloter)
				{
					mAPloter = new CList <XMPloter *>;plter=new XMPloter(ob);
					mAPloter->Add(plter);
				} else mAPloter->MoveLast(plter);
				plter->Add(ob);
			}
	}
}

int XMPlot::Dim()
{
	int dim=2;
	XMPloter *plt;
	if (!mAPloter) return dim;
	for (mAPloter->MoveFirst(plt);!mAPloter->Eol();mAPloter->MoveNext(plt)) dim=(plt->Dim() <= 2?dim: plt->Dim());
	return dim;
}

XMPlot2D::XMPlot2D():XMPlot(TO_PLOT3D)
{
}

char *XMPlot2D::Formatted()
{
	char *formatted;
	
	formatted = new char[999999];
	printf("==============  Type:  %d   ================\n", mType);
	sprintf(formatted, "%d#%s#", mType, mName);
	return formatted;
}

XMMap* * XMPlot2D::Tracer(int ko=-1)
{
	if (!mAPloter) return NULL;
	//if (ko != -1) return (XMMap **)(&Map(mAPloter->Get(ko)));
	XMMap **map;
	int k=0;
	ko=mAPloter->GetCount();
	map = new (XMMap *)[ko+1];
	map[ko] = NULL;
	XMTRACE("Entrer de Tracer [%p] %d\n",mAPloter,ko);
	if (!mSyscoord) mSyscoord = mAPloter->Get(k)->Method()->DefaultAxis();
	for(k=0; k<ko; k++) map[k] = Map(mAPloter->Get(k));
	XMTRACE("Fin Map\n");
	return map;
}

XMMap * XMPlot2D::Map(XMPloter *plt)
{
	XMTRACE("Entrer dans Map [%p]:[%p]\n",Syscoord(),mAPloter);
	if (!plt) return 0;
	XMTRACE("Creation d'un Map\n");
	XMMap *map = new XMMap(plt->Dim());
	XMTRACE("Map\n");
	return (MapBis(map, plt, mAPloter->GetCount()) ? map: NULL);
}

int XMPlot::MapBis(XMMap *map, XMPloter *plt, int num)
{

	if (!plt) return 0;
	XMTRACE("Syscoord d'un Map  %p\n",mSyscoord);
	if (!plt->Intervalles()) return (int)(map=(XMMap *)(plt->Map((CList <XMObjectX *>*)(mSyscoord?mSyscoord->Intervalles():NULL))));
	XMIntervalle *in;
	if (!(in = plt->Intervalles()->Get(num))) return 0;
	while (in->IsValid())
	{
		if (!num) MapBis(map, plt, num-1); else
		//map->Add(plt->Reach(plt->Intervalles(), mSyscoord->Intervalles()));
		in->Inc();
	}
	in->Init();
	return 1;
}

void  XMPlot::Lecture()
{
	XMTRACE("============ Lecture de l'objet XMPlot ============\n");
	if (mSyscoord) XMTRACE("Syscoord:\n"); else XMTRACE("Aucun systeme de coordonnees defini\n");
	if (mAPloter)
	{
		XMTRACE("Nbre d'objet a tracer: %d\n",mAPloter->GetCount());
		XMPloter *plt;
		for (mAPloter->MoveFirst(plt);!mAPloter->Eol();mAPloter->MoveNext(plt)) plt->Lecture();
	} else XMTRACE("Aucun objet a tracer\n");
	XMTRACE("===================================\n");
}
/*
XMPlot3D::XMPlot3D():XMPlot(TO_PLOT3D)
{
}*/

XMMap ** XMPlot3D::Tracer(int k=-1)
{
	return NULL;
}

XMMap  * XMPlot3D::Map(XMPloter *plt)
{
	return NULL;
}