 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: syscoord.cpp,v 1.2 2000/11/02 22:09:51 daville Exp $
 * $Log: syscoord.cpp,v $
 * Revision 1.2  2000/11/02 22:09:51  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include "syscoord.h"


SysCoord::SysCoord(XMObjectX *ob)
{
	mType = TO_SYSCOORD;
	mAxes = NULL;
	mDim = 0;
	if (ob->Type() != TO_INTERVALLE) return;
	mAxes = new CList<XMIntervalle *>;
	mAxes->Add((XMIntervalle *)ob);
}

SysCoord::SysCoord(int dim)
{
	mType = TO_SYSCOORD;
	mAxes = NULL;
	mDim = 0;
	if ((dim>3) || (dim<=0)) return;
	mDim = dim;
	mAxes = new CList<XMIntervalle *>;
}

void SysCoord::ConfigureAxe(int no, char *nom, double min=-5, double max=5)
{
	if (mDim>no) mAxes->Add(new XMIntervalle(nom, new XMVariable(NULL,NULL,min), new XMVariable(NULL,NULL,max)));
}

SysCoord::~SysCoord()
{
	if (!mAxes) return;
	delete mAxes;
	mAxes = NULL;
}