 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: syscoord.h,v 1.2 2000/11/02 22:09:51 daville Exp $
 * $Log: syscoord.h,v $
 * Revision 1.2  2000/11/02 22:09:51  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef SYSCOORD_H
#define SYSCOORD_H
#include "Liste.h"
#include "intervalle.h"

class SysCoord: public XMObjectX
{
	CList <XMIntervalle *> *mAxes;
	int mDim;
public:
	SysCoord(){mType = TO_SYSCOORD;mAxes=NULL; mDim=0;}
	SysCoord(XMObjectX *ob);
	SysCoord(int dim);
	void ConfigureAxe(int no, char *nom, double min=-5, double max=5);
	void Add(XMIntervalle *in){if (!mAxes) mAxes = new CList<XMIntervalle *>;mAxes->Add(in);}
	char* GetNameAxe(int no){return ((mAxes)?mAxes->Get(no)->GetName():NULL);}
	double GetValAxe(int k, int born){return ((mAxes)?mAxes->Get(k)->GetVal(born):0);}// born: 0<==> Max, 1<==> Min;
	int Dim(){return ((mAxes)?mAxes->GetCount():0);}
	XMIntervalle *Intervalle(int k){return ((mAxes)?mAxes->Get(k):NULL);}
	CList <XMIntervalle *> *Intervalles(){XMTRACE("Intervalle renvoye\n");return mAxes;}
	
        char *Formatted(){return NULL;}
	TYPE  Eval(int &i, CList <XMObjectX *> *lvar=NULL){return 0;}
        char *EvalF(int &i, CList <XMObjectX *> *lvar=NULL){return (char *)0;}
        char *Affiche(){return (char *)0;}
        void  Lecture(){return ;}
        XMObjectX *XEval(int &i, CList <XMObjectX *> *lvar=NULL){return (XMObjectX *)0;}
        XMObjectX *Diff(char *x){return (XMObjectX *)0;}
        XMObjectX *Clone(){return (XMObjectX *)0;}
	
	~SysCoord();
};

#endif	/* SYSCOORD_H */