 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: variable.cpp,v 1.2 2000/11/02 22:09:51 daville Exp $
 * $Log: variable.cpp,v $
 * Revision 1.2  2000/11/02 22:09:51  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include "variable.h"

XMVariable::XMVariable()
{
        mType = TO_VARIABLE;
        mExpression[0] = mExpression[1] = mName = NULL;
        mVal = 0.0;
}

XMVariable::XMVariable(XMVariable &var)
{
        int vld;
        mType = TO_VARIABLE;
        SetName(var.GetName());
	for (int i=0; i<2; i++) SetExp(i, var.GetExp(i));
        mVal = var.Eval(vld);
}


XMVariable::XMVariable(char *nom)
{
        mType = TO_VARIABLE;
        SetName(nom);
        for (int i=0; i<2; i++) SetExp(i, nom);
        mVal = 0.0;
}

XMVariable::XMVariable(char *nom, char *vals, TYPE val)
{
	mType = TO_VARIABLE;
	SetName(nom);
        for (int i=0; i<2; i++) SetExp(i,vals);
        mVal = val;
}

XMObjectX *XMVariable::Clone()
{
        return new XMVariable(*this);
}

XMObjectX *XMVariable::Diff(char *x)
{
        XMVariable *va;
        char *nom;
        nom = new char[strlen(mName)+2];
        sprintf(nom, "%s'", mName);
        va = new XMVariable(nom);
        if (!strcmp(x, mName))
        {
               	va->SetValueS("1");
        	va->SetValue(1);
        } else
        {
               	va->SetValueS("0");
        	va->SetValue(0);
        }
        return va;
}

char *XMVariable::Formatted()
{
	char *formatted;
	
	formatted = new char[100];
	sprintf(formatted, "%d#%s#%s#%f#", mType, mName, mExpression[1], mVal);
	return formatted;
}

TYPE  XMVariable::Eval(int &i, CList <XMObjectX *> *lvar=NULL)
{
        return mVal;
}

char *XMVariable::EvalF(int &i, CList <XMObjectX *> *lvar=NULL)
{
        return Copie(0, strlen(mExpression[1]), mExpression[1]);
}

void  XMVariable::SetValue(TYPE val)
{
        mVal = val;
}

void  XMVariable::SetValueS(char *vals)
{
        for (int i=0; i<2; i++) SetExp(i, vals);
}

char *XMVariable::Affiche()
{
        int n;
        char *aff;
        n = strlen(mName);
        n = n + 1;
        n = n + strlen(mExpression[1]);
        aff = new char[n+1];
        strcpy(aff, mName);
        strcpy(aff, "=");
        strcpy(aff, mExpression[1]);
        return aff;
}

void  XMVariable::Lecture()
{
        printf("Type: 		Variable\n");
        printf("ID		%d_n", mType);
        printf("Nom:		%s\n", mName);
        printf("Valeur:		%s\n", mExpression[1]);
}

XMVariable::~XMVariable()
{
}
