 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: vecteur.h,v 1.2 2000/11/02 22:09:51 daville Exp $
 * $Log: vecteur.h,v $
 * Revision 1.2  2000/11/02 22:09:51  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef VECTEUR_H
#define VECTEUR_H
#include "mobjectx.h"

class XMVecteur: public XMObjectX
{
        int mDim;
        XMObjectX **mVect;
       	public:
       	XMVecteur();
       	XMVecteur(XMVecteur &vect);
       	XMVecteur(int dim);
       	void SetDim(int dim);
       	int  GetDim();
       	void SetCoord(XMObjectX *mobj, int rg);
       	XMObjectX *GetCoord(int rg);
       	void DeleteCoord(int rg);
       	XMObjectX *Clone();
       	XMObjectX *Diff(char *x);
        char *Formatted();
       	XMObjectX *XEval(int &i, CList <XMObjectX *> *lvar=NULL){return (XMObjectX *)0;}
       	void  Lecture();
       	char  *Affiche();
       	char *EvalF(int &vld, CList <XMObjectX *> *lvar=NULL);
       	TYPE  Eval(int &vld, CList <XMObjectX *> *lvar=NULL);
       	~XMVecteur();
};

#endif	/* VECTEUR_H */