 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: FileArch.h,v 1.2 2000/11/02 22:29:12 daville Exp $
 * $Log: FileArch.h,v $
 * Revision 1.2  2000/11/02 22:29:12  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef FILE_ARCH_H
#define FILE_ARCH_H
#include <vdk/menu.h>

class ItemFileArch;

/********************************************************************************************************/
/********************************************************************************************************/
/*				CLASS englobant les Items de fichier					*/
/********************************************************************************************************/
class FileArch: public VDKObject
{
private:
	int mMax;
	int mPosition;
	char **mTABItemFileArch;
public:
	FileArch(int max);
	void AddItemFileArch(VDKMenu *menu,char *itemu, bool (VDKObject::*Hld)(VDKObject *sender));
	void DelItemFileArch(int pos, char *name);
	void CheckedItemFichier(char *name, VDKMenuItem *item);
	void Rafraichir(VDKMenu *menu, bool (VDKObject::*Hld)(VDKObject *sender));
	//ItemFileArch *GetItemFileArch(VDKMenuItem *item);
	~FileArch();
};

/********************************************************************************************************/


/********************************************************************************************************/
/********************************************************************************************************/
/*				CLASS pour les Items de fichier						*/
/********************************************************************************************************/
class ItemFileArch
{
private:
	VDKMenuItem *mItem;
	char *mName;
	
public:
	ItemFileArch();
	ItemFileArch(VDKMenuItem *item, char *name);
	void SetName(char *name);
	char *GetName();
	VDKMenuItem *GetMenuItem();
	~ItemFileArch();
};
/*******************************************************************************************************/

#endif   /* FILE_ARCH_H */