 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: bibliotheque.cc,v 1.2 2000/11/02 22:29:12 daville Exp $
 * $Log: bibliotheque.cc,v $
 * Revision 1.2  2000/11/02 22:29:12  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


/*
bibliotheque Form
implementation file:bibliotheque.cc
*/
#include <bibliotheque.h>
#include <Core/type.h>
#include <Core/utils.h>
#include <VGlobal.h>
//#include <IMemory.h>
// Bibliotheque FORM  CLASS
/*
form constructor
*/
BibliothequeForm::BibliothequeForm(VDKForm* owner, char* title):
	VDKForm(owner,title)
{
	mMode = 0;
}

void BibliothequeForm::SetMode(int mode)
{
	char *Row[BIB_MAX_COLUMNS];
	XMObjectX *objectx;
	mMode = mode;
	switch (mMode)
	{
		// Bibliotheque standard
		case 1:
			mAjouter->Enabled = FALSE;
	       		mSupprimer->Enabled = FALSE;
	       		for (int i=0; XM_STANDARD_FUNCTIONS[i]; i += BIB_MAX_COLUMNS)
	       		{
	       			for(int j=0; j<BIB_MAX_COLUMNS; j++) Row[j] = XM_STANDARD_FUNCTIONS[i+j];
				mList->AddRow(Row);
	       		}
			break;
		// Bibliotheque EasyMaths
		case 2:
			mAjouter->Enabled = FALSE;
	       		mSupprimer->Enabled = FALSE;
	       		for (int i=0; XM_EASYMATHS_FUNCTIONS[i]; i += BIB_MAX_COLUMNS)
	       		{
	       			for(int j=0; j<BIB_MAX_COLUMNS; j++) Row[j] = XM_EASYMATHS_FUNCTIONS[i+j];
				mList->AddRow(Row);
	       		}
	       		break;
		// Bibliotheque utilisateur
		case 3:
			/*for (int i=0; objectx = GetMemory()->get(i); i ++)
	       		{
	       			Row[0] = GetGroupeName(objectx->Type());
	       			Row[1] = objectx->GetName();
	       			Row[2] = objectx->GetExp(1);
				mList->AddRow(Row);
	       		}*/
			break;
		default:
			break;
	}
}

/*
form destructor
*/
BibliothequeForm::~BibliothequeForm()
{
}

/*
form setup
*/
void
BibliothequeForm::Setup(void)
{
	GUISetup(); // vdkb gui setup
// put your code below here

}
