 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: easymaths.h,v 1.2 2000/11/02 22:29:12 daville Exp $
 * $Log: easymaths.h,v $
 * Revision 1.2  2000/11/02 22:29:12  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


/*
easymaths Application
Main unit header file: easymaths.h
*/
#ifndef _easymaths_main_form_h_
#define _easymaths_main_form_h_
#include <vdk/vdk.h>
#include <vdk/vdkthread.h>
#include <VGlobal.h>
#include <FileArch.h>
#include <Core/Assistant.h>
#include <ClientCommunication.h>
#include <progress.h>

// Easymaths FORM  CLASS
class EasymathsForm: public VDKForm, public HandleServer
{
// gui object declarations
	SCConnection *mConnection;
	ProgressForm *mProgress;
	bool IsRunning;
        char mTitle[400];
        char mCurrentFile[EAS_MAX_FILELEN];
        FileArch *mListOldFile;
private:
// vdkbuilder reserved gui construction
	void GUISetup(void);

public:
	EasymathsForm(VDKApplication* app, char* title);
	/*void FilterReponseCreate(CReponse *aRep);*/
	void *LancerRun(void *sender);
	void TreateReponse(XMReponse *aRep);
        void TreateObjectX(XMReponse *objectx);
        void UpdateTitle(bool modified);
	~EasymathsForm();
	void Setup(void);
	void InitialiserMenuFichiers();
/*
 gui setup include 
 do not patch below here
*/
#include <easymaths_gui.h>
};

// Easymaths APPLICATION  CLASS
class EasymathsApp: public VDKApplication
{

public:
	EasymathsApp(int* argc, char** argv);
	~EasymathsApp();
	void Setup(void);
};

#endif