 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: memory.h,v 1.2 2000/11/02 22:30:20 daville Exp $
 * $Log: memory.h,v $
 * Revision 1.2  2000/11/02 22:30:20  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


//=======================================
#ifndef _MEMORY_h
//====== put your code below here =======
#define _MEMORY_h

#include <vdk/dlist.h>

template <class X, class T> class Memory: public VDKList<T>
{
	int mMaxi;
	int mCompter;
public:
	Memory(){mCompter = 0; mMaxi = -1;};
	Memory(int maxi = -1){mCompter = 0; mMaxi = maxi;};
	void add(T *t);
	int remove(T* x);
	void flush();
	T *get(int i);
	T *find(char *name);
	~Memory(){};
};

template <class X, class T> void Memory<X, T>::add(T *t)
{
	if ((mMaxi>0) && (mCompter>mMaxi)) return;
	mCompter++;
	VDKList<T>::add(t);
}

template <class X, class T> int Memory<X, T>::remove(T* x)
{
	mCompter--;
	return (VDKList<T>::remove(t));
}

template <class X, class T> void Memory<X, T>::flush()
{
	mCompter = 0;
	VDKList<T>::flush();
}

template <class X, class T> T *Memory<X, T>::get(int i)
{
	
	return (((size()==0) || (i>=size()) || (i<0))?0:VDKList<T>::operator[](i));
}

template <class X, class T> T *Memory<X, T>::find(char *name)
{
	T* Result = 0;
	int n = size();
	for (int i=0; (!Result) && (i<n); i++)
		if (!strcmp((Result=VDKList<T>::operator[](i))->GetName(), name)) Result = 0;
	return Result;
}

//=======================================
#endif
