#! /bin/sh
 ########################################################################
 # =======================================				#
 # EasyMaths - Configuration component of EasyMaths			#
 # November 2000							#
 # =======================================				#
 #									#
 # Copyright (C) 2000, 2001 Didier Davill				#
 # Developed by Didier Davill <Didier.Daville@ddarea.com>		#
 #									#
 # This library is free software; you can redistribute it and/or modify #
 # it under the terms of the GNU Library General Public License as 	#
 # published by the Free Software Foundation; either version 2 of the	#
 # License, or (at your option) any later version.			#
 #									#
 # This library is distributed in the hope that it will be useful, but	#
 # WITHOUT ANY WARRANTY; without even the implied warranty of		#
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			#
 # See the GNU Library General Public License for more details.		#
 #									#
 # You should have received a copy of the GNU Library General Public	#
 # License along with this library; if not, write to the Free Software	#
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		#
 # 02111-1307, USA.							#
 ########################################################################

 ########################################################################
 # $Author: daville $
 #
 # $Revision: 1.4 $
 #
 # $Id: Version.sh,v 1.4 2000/11/05 17:21:05 daville Exp $
 # $Log: Version.sh,v $
 # Revision 1.4  2000/11/05 17:21:05  daville
 # Ajout des termes GNU.
 # Modification de la destination du fichier config gnr suite  la nouvelle configuration de l'environnement.M
 # Modification du message de prsentation de EasyMaths
 #
 #
 ########################################################################


#########################################
#		Version.sh		#
#					#
#########################################

#########################################
# Cet outil permet la mise  jour des   #
# versions				#
# $Author: daville $
# $Id: Version.sh,v 1.4 2000/11/05 17:21:05 daville Exp $
# $Log: Version.sh,v $
# Revision 1.4  2000/11/05 17:21:05  daville
# Ajout des termes GNU.
# Modification de la destination du fichier config gnr suite  la nouvelle configuration de l'environnement.M
# Modification du message de prsentation de EasyMaths
#
# Revision 1.3  2000/11/03 20:56:34  daville
# Ajout des termes de license et de garantie.
#
# Revision 1.2  2000/11/01 19:22:15  daville
# Modification de la mthode de calcul des versions.
#
#
#########################################

## Initialisation des constantes ########
NOM_OUTIL=`basename $0`
#########################################


## Initialisation des paramtres ########
DATE=`date`
AUTEUR="Didier Davill"
ADRESSE_AUTEUR="Didier.Daville@LibertySurf.fr"
DEFAULT_MODULE=EasyMaths
FICHIER_HEADER_CONFIG="$REP_SRC_IHM_EASYMATHS_RELEASED/Config.h"
#########################################


## Cration de l'archivage ##############
AfficherAide ( )
{
cat <<FIN

 ************************************************
  Version version 1.1.4
  Copyright (C) 2000 EasyMaths of Didier Davill
  Version comes with ABSOLUTELY NO WARRANTY.
  This is free software, and you are welcome to
  redistribute it under certain conditions.
 *************************************************

FIN
	echo "Mode d'utilisation "
	echo "	version [OPTION] [MODULE]"
	echo "  Avec OPTION"
	echo "	-h			Affiche l'aide"
	echo "	-help			Affiche l'aide"
	echo "	-next 	 [MODULE]	Affiche la prochaine version de module"
	echo "	-current [MODULE]	Affiche la version courante de module"
}
#########################################


## Cration de l'archivage ##############
CreerFichierHeaderConfig ( )
{
	# Mise  jour du fichier Config.h
	cat <<FIN >"$FICHIER_HEADER_CONFIG"
 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core/IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

FIN

	echo "// Fichier gnr le "$DATE" par l'utilitaire Version">>$FICHIER_HEADER_CONFIG
	echo "		">>$FICHIER_HEADER_CONFIG
	echo "#ifndef XM_CONFIG_H" >>$FICHIER_HEADER_CONFIG
	echo "#define XM_CONFIG_H" >>$FICHIER_HEADER_CONFIG
	echo >>$FICHIER_HEADER_CONFIG
	echo "#define XM_AUTEUR			\"$AUTEUR\"" >>$FICHIER_HEADER_CONFIG
	echo "#define XM_ADRESSE_AUTEUR		\"$ADRESSE_AUTEUR\"" >>$FICHIER_HEADER_CONFIG
	echo "#define XM_VERSION_MAYOR		\"`"$NOM_OUTIL" -current| cut -d. -f1`\""  >>$FICHIER_HEADER_CONFIG
	echo "#define XM_VERSION_MEDIUM		\"`"$NOM_OUTIL" -current| cut -d. -f2`\"" >>$FICHIER_HEADER_CONFIG
	echo "#define XM_VERSION_MINOR		\"`"$NOM_OUTIL" -current| cut -d. -f3`\""  >>$FICHIER_HEADER_CONFIG
	echo "#define XM_VERSION			\"`"$NOM_OUTIL" -current`\"" >>$FICHIER_HEADER_CONFIG
	echo "#define XM_LAST_VERSION_DATE		\"$DATE\""  >>$FICHIER_HEADER_CONFIG
	echo >>$FICHIER_HEADER_CONFIG
	echo "#endif   /*XM_CONFIG_H*/" >>$FICHIER_HEADER_CONFIG
	cp -f "$FICHIER_HEADER_CONFIG" "$REP_SRC_CORE_EASYMATHS_RELEASED"
}
#########################################

## Operation de version #################
function UpdateVersion ( )
{
	Action="$1"
	Module="$2"
	FICHIER_VERSION="$3"
	VERSION_MODULE_VALUE=`grep %$Module% $FICHIER_VERSION`
	if [ X"$VERSION_MODULE_VALUE" = X ]; then
		RESULT=no
		return
	fi
	OLD_VERSION_MODULE=`echo $VERSION_MODULE_VALUE|cut -d: -f6`
	VERSION_MAYOR=`echo $OLD_VERSION_MODULE | cut -d. -f1`
	VERSION_MEDIUM=`echo $OLD_VERSION_MODULE | cut -d. -f2`
	VERSION_MINOR=`echo $OLD_VERSION_MODULE | cut -d. -f3`
	VERSION_MINOR=`expr $VERSION_MINOR $Action 1`
	if [ "$VERSION_MINOR" = "100" ]; then
		VERSION_MINOR=0
		VERSION_MEDIUM=`expr $VERSION_MEDIUM $Action 1`
		if [ "$VERSION_MEDIUM" = "100" ]; then
			VERSION_MEDIUM=0
			VERSION_MAYOR=`expr $VERSION_MAYOR $Action 1`
		fi
	fi
	NEW_VERSION_MODULE="$VERSION_MAYOR.$VERSION_MEDIUM.$VERSION_MINOR"
	NEW_VERSION_MODULE_VALUE=`echo $VERSION_MODULE_VALUE|sed s/$OLD_VERSION_MODULE/$NEW_VERSION_MODULE/g`
	
	cp $FICHIER_VERSION $FICHIER_VERSION.sav
	sed s/$VERSION_MODULE_VALUE/$NEW_VERSION_MODULE_VALUE/g $FICHIER_VERSION.sav>$FICHIER_VERSION
	rm $FICHIER_VERSION.sav
	if [ $Module=$DEFAULT_MODULE ]; then
		CreerFichierHeaderConfig
	fi
}
#########################################


## Procdure principale	#################
ProcedurePrincipale ( )
{
	Option=$1
	if [ $# = 2 ]; then
		Module=$2
	else
		Module=$DEFAULT_MODULE
	fi
	case $Option in
		-h)AffichierAide;;
		-help) AfficherAide;;
		-prev) UpdateVersion "-" "$Module" "$FICHIER_CONFIG_MODULE";;
		-next) UpdateVersion "+" "$Module" "$FICHIER_CONFIG_MODULE";;
		-current)
			VERSION_FOUND=`grep %$Module% $FICHIER_CONFIG_MODULE|cut -d: -f6`
			if [ X"$VERSION_FOUND" = X ]; then
				grep "%$Module%" $FICHIER_CONFIG_MODULE_INFO|cut -d: -f6
				exit 0
			fi
			echo "$VERSION_FOUND"
			;;
		-creerconfig) CreerFichierHeaderConfig;;
		*) AfficherAide;;
	esac
}
#########################################


## Lancement de la procedure principale #
ProcedurePrincipale $* ##################
#########################################